/* 

   libmidi.c

   Must be linked with the main program.
   fork & exec callplaymidi
   To play a midi file just send the name.   


   May 1996
   Xavier HOSXE

*/

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include <sys/wait.h>


#define OK 1
#define ERROR 0


short midi=0;
int pipe1[2];
int pipe2[2];
int pidCallplaymidi=0;
struct stat pipeStat;
int Max;
char output[]="--";
int status;

/* ----- Midi =0 ----- */

void Midi_problem(int sig) {
  midi=0;
  printf("libmidi : playmidi seems to make problems\n");
  signal(SIGUSR1,Midi_problem);
}

/* ------- Stop Music ------------ */

void Midi_stop_music() {
  if (pidCallplaymidi) {
    /*printf("Try to stop callplaymidi %i \n",pidCallplaymidi);  */
    kill(pidCallplaymidi,SIGUSR1);
  }
}

/* ------- fin ------------ */

void Midi_end() {
  if (pidCallplaymidi) {
    /*printf("libmidi :  callplaymidi exit... \n");*/
    kill(pidCallplaymidi,SIGUSR2);
    midi=0;
    wait(&status);
  }
}

/* ------ attente ----------- */

void waitForPipe() {
  /*printf("programme : Attente \n");*/
  do {
    if (fstat (pipe2[0],&pipeStat)) {
      printf("libmidi :Erreur dans boucle d'attente\n");
      exit(0);
    }
  } while (!pipeStat.st_size);   
}

/* --------- Initialisation du process MidiProcess -------------- */

void Midi_init(short card) {
  char zero = 0;
  char result;
  char charPip10[10];
  char charPip11[10];
  char charPip20[10];
  char charPip21[10];
  FILE *test;

  midi=0;

  // No midi music !
  if (card==0) {
    return;
  }

  /* -- Just to check there's a sound card driver -- */
  if ((test=fopen("/dev/sequencer","r"))==NULL) {
    printf("libmidi : no sound card driver installed\n");
    midi=0;
    fclose(test);
    return;
  }
  fclose(test);

  signal(SIGUSR1,Midi_problem);

  if (card==1) {
    strcpy(output,"-g");
  } else if (card==2) {
    strcpy(output,"-f"); 
  } else  if (card==3) {
    strcpy(output,"-e");
  } else {
    printf("libmidi : Midi_init %i unknown card !\n",card);
    return;
  }

  if (pipe(pipe1)) return;
  if (pipe(pipe2)) return;

  sprintf(charPip10,"%i",pipe1[0]);
  sprintf(charPip11,"%i",pipe1[1]);
  sprintf(charPip20,"%i",pipe2[0]);
  sprintf(charPip21,"%i",pipe2[1]);
  

  if (!(pidCallplaymidi=fork())) {
    /* ----- process fils ------- */
    /*printf(" Exec : callplaymidi %s %s %s %s %s \n",output,charPip10,charPip11,charPip20,charPip21);*/
    execlp("callplaymidi","callplaymidi",output,charPip10,charPip11,charPip20,charPip21,0);
    write(pipe2[1],&zero,1);
    exit(0);
  }
  
  close(pipe1[0]);
  close(pipe2[1]);

  waitForPipe();
  read(pipe2[0],&result,1);

  if (result) {
    /*    printf("libmidi : callplaymidi fork OK !\n");*/
    usleep(100000);
    midi= 1;
  } else {
    printf("libmidi :  callplaymidi not here !\n");
    pidCallplaymidi=0;
  }
}


/* --------- Load & play ------------- */

void Midi_play(char *midiFile) {
  if (midi) {
    Midi_stop_music();
    /*printf("libmidi : chanson %s envoye a callplaymidi \n",midiFile);*/
    write(pipe1[1],midiFile,strlen(midiFile));  
  }
}



