/*

   Animation.cc
   class Animation is a list of Graph

   Xavier HOSXE
   */

#include <stdio.h>
#include <string.h>
#include "Animation.h"
#include "GraphElem.h"

extern void restore_all(int);

#define GUNZIP "gzip -c -d"

void Animation::Load(char *nomFichier) {
  int n,x,y,k;
  FILE *fichier;
  GraphElem *graphelem;
  int globalx1,globalx2,globaly1,globaly2,o,p;
  char *command;


  command = new char [strlen(GUNZIP)+strlen(nomFichier)+7];
  sprintf(command,"%s '%s.gz'",GUNZIP,nomFichier);
  fprintf(stderr,".");
  if ((fichier=popen(command,"rb"))==NULL) {
    fprintf(stdout,"No Sprite file : %s \n", nomFichier);
    restore_all(1);
  }

  fread(&n,4,1,fichier); 
  fread(&x,4,1,fichier); 
  fread(&y,4,1,fichier);

  globalx1=x;
  globalx2=0;
  globaly1=y;
  globaly2=0;
  //  printf("Essai...%s \n",nomFichier);

  for (k=0;k<n;k++) {
    graphelem = new GraphElem(x,y);
    fread( graphelem->mpattern ,1,x*y,fichier); 
    for (p=0;p<y;p++) 
      for (o=0;o<x;o++) {
	if ((o<globalx1) && (graphelem->mpattern[o+p*y]))
	  globalx1=o;
	if ((o>globalx2) && (graphelem->mpattern[o+p*y]))
	  globalx2=o;
	if ((p<globaly1) && (graphelem->mpattern[o+p*y]))
	  globaly1=p;
	if ((p>globaly2) && (graphelem->mpattern[o+p*y]))
	  globaly2=p;
      }
    Add(graphelem);   
  }
  if (First()) {
    do {
      ((GraphElem *)mcurrent)->ReForm(globalx1,globalx2,globaly1,globaly2);
    } while (Next());
  }
  //printf("--> (%i,%i) -> (%i,%i) \n",globalx1,globaly1,globalx2,globaly2);

  pclose(fichier);
  //printf("OK...\n");
}

void Animation::SetSize(short x, short y) {
  if (First()) {
    do {
      ((GraphElem *)mcurrent)->SetSize(x<<4,y<<4);
      ((GraphElem *)mcurrent)->SetCenter(x<<3,y<<3);
    } while (Next());
  }
}


