/*

  Definition of the Last Space Ship.

  Xavier HOSXE
  
  */


#include <stdio.h>
#include <stdlib.h>
#include <ListSprite.h>
#include <string.h>
#include "SpaceShips.h"
#include "LastSpaceShip.h"


#define MCURRENT ((GraphElem *) mcurrent)

extern short fin;
extern int highScore;
extern short level,often,snd;
extern void restore_all(int);
extern short triplefire;
extern short backfire;


/* ---------------------- Last Space Ship --------------------- */

LastSpaceShip::LastSpaceShip(ListSprite *list,short speed,short power) : SpriteElem(list){
  mchanel = 0;
  mpower = power;
  mspeed = speed;
  mstate = CREATION;
  mtype = LASTSPACESHIP;
  Copy(alastspaceship);
  ((ListSprite *)list)->mnombre[LASTSPACESHIP]++;
  SetLocation(700<<4,150<<4);
} 

void LastSpaceShip::ContactWith(Sprite *sp) {
  if (mstate==NORMAL) {
    switch (sp->mtype) {   
    case MYFIRE:
      if (((my-sp->my)<240) && (my-sp->my>120)) {
	mpower -= ((MyFire *)sp)->mpower;
	//printf("POWER : %i \n",mpower);
	if (mpower<=0) {
	  Die();
	  mtime = 0;
	  ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(2500);
	  SetDirection(0,0);
	  mstate = FINALEXPLOSION;
	  if (snd) Snd_effect(9,mchanel++);
	  if (snd) Snd_effect(10,mchanel++);
	  if (snd) Snd_effect(3,mchanel++);
	  if (snd) Snd_effect(4,mchanel++);
	} else {
	  SetDirection(64,0);
	  Copy(alastspaceshipexplosion);
	  mstate = DESINTEGRATION;
	  ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(500);  
	  mtime =1;
	  if (snd) Snd_effect(17,CHFOES1);
	}
      }
      break;
    default:
      break;
    }
  }
}



void LastSpaceShip::Move() {
  switch(mstate) {
  case CREATION:
    SetDirection(-8,0);
    if (mx<=9600) {
      SetDirection(0,0);
      mstate = NORMAL;
    }
    break;
  case ATTACKBEGIN:
    // printf("AB(%i,%i)",mx>>4,my>>4);
    if (mx<=max) {
      //printf("ATTACKEND...\n");
      mstate = ATTACKEND;
      Copy(alastspaceshipattack);
      mtime=0;
      mvarfire2 = 0;
      GoTo(mox,moy,10);
    }
    break;
  case ATTACKEND:
    mvarfire2 ++;
    if (!(mvarfire2 & 3)) {
      Fire2();
    }
    if (mx>=9600) {
      //printf("Fin de l'attaque.\n");
      mx=9600;
      SetDirection(0,0);
      mstate = NORMAL;
      Copy(alastspaceship);
      mcurrent = mlast;
    }
    break;

  case NORMAL:
    //printf(".");
    mdy = (((SpriteElem *)mlist->mfirst)->my-my)/150*level;  
    if (!(random() & ((mspeed*2)-1))) {
      Fire1();
      mstate = SHOOTING;
      mtime = 0;
    } else if (!(random() & ((mspeed*2)-1))) {
      //printf("ATTACKBEGIN...\n");
      mox = mx;
      moy = my;
      max=((SpriteElem *)mlist->mfirst)->mx;
      may=((SpriteElem *)mlist->mfirst)->my;
      GoTo(max,may,15+level*3);
      mstate = ATTACKBEGIN;
      Copy(alastspaceshipattack2);
      mtime=0;
      //printf(" mo (%i,%i) ma (%i,%i) m (%i,%i)\n",mox>>4,moy>>4,max>>4,may>>4,mx>>4,my>>4);
    } else if (!(random() & ((mspeed*4)-1))) {
      //printf("Creation robot\n");
      mstate = CREATIONROBOT1;
      mox=mx;
      moy=my;
      GoTo(9600,HEIGHT4-SOL,15); // 9600 = 600*16   
    }
    break;

  case NOWHERE:
    if (!(random() & 31)) {
      mstate = CREATION;
      mcurrent = mfirst;
      SetLocation(700<<4,((random() % 255)+130)<<4);
    }
    break;
      
  case CREATIONROBOT1:
    if (my>=HEIGHT4-SOL) {
      SpriteElem *sprite;
      
      sprite = new Enemy3((ListSprite *)mlist,100,63);
      sprite->SetLocation(mx,417<<4);
      sprite->SetDirection(-12,0);
      GoTo(mox,moy,15);
      mstate = CREATIONROBOT2;
      mlist->Add(sprite);
    }
    break;

  case CREATIONROBOT2:
    if (my<=moy) {
      mstate = NORMAL;
      SetDirection(0,0);
    }
    break;

  case FINALEXPLOSION:
    mtime++;  
    /*    if (my<(HEIGHT4-SOL+(MCURRENT->get_mheight()))) {
      if (my<HEIGHT4-SOL) {
	Explosion *sprite;
	
	sprite = new Explosion((ListSprite *)mlist,this);
	sprite->SetLocation(mx+(((random()& 63)-32)<<4),my+(((random()& 63)-32)<<4));
	sprite->SetDirection(mdx,mdy);
	sprite->Copy(aexplosion1lastspaceship);
	mlist->Add(sprite);
	if (!(random() & 7)) {
	  switch (random() & 3) {
	  case 0:
	  Snd_effect(10,mchanel);
	    break;
	  case 1:
	    Snd_effect(9,mchanel);
	    break;
	  case 2:
	    Snd_effect(3,mchanel);
	    break;
	  case 3:
	    Snd_effect(4,mchanel);
	    break;
	  } 
	}
	mchanel = (mchanel +1 ) %5;
      }
      if (!(mtime & 7)) mdy+=1;
    } else {
      vie=0;
    }*/
    break;
  }   
  Update();  
}

void LastSpaceShip::Die() {

  if (mlist->First()) {
    do {
      switch (((SpriteElem *)((ListSprite *)mlist)->mcurrent)->mtype) {
      case ENEMY3:
	(((Enemy3 *)((ListSprite *)mlist)->mcurrent)->Die());
	break;
      case ENEMY3FIRE:
	(((Enemy3Fire *)((ListSprite *)mlist)->mcurrent)->Die());
	break;
      default:
	break;
      }
    } while (mlist->Next());
  }
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(alastspaceshipexplosion);
  ex->SetDirection(12,0);
  mlist->Add(ex);
  vie=0;
  Snd_effect(10,mchanel);
  Snd_effect(9,mchanel);
  Snd_effect(3,mchanel);
  Snd_effect(4,mchanel);
}

void LastSpaceShip::Draw() {
  switch(mstate) {
  case ATTACKBEGIN:
    if (!((mtime++) & 3))
      if (!Next()) mcurrent=mlast;
    break;
  case ATTACKEND:
    if (!((mtime++) & 3))
      if (!Prev()) mcurrent=mfirst;
    break;
  case CREATION:
  case NORMAL:
    mcurrent = mfirst;
    break;
  case CREATIONROBOT1:
    break;
  case DESINTEGRATION:
    if (!(mtime & 3)) {
      Next();
    }
    if (mtime == 12) {
      mstate = NOWHERE;
      Copy(alastspaceship);
    }
    mtime++;
    break;
  case SHOOTING:
    Copy(alastspaceshipattack);
    mtime ++;
    break;
  default:
    break;
  }

  gl_putboxmask((-MCURRENT->mxCenter+mx)>>4,
                ((-MCURRENT->myCenter+my)>>4)+(pageFlipping[!page]),
                MCURRENT->mwidth>>4,
                MCURRENT->mheight>>4,
                MCURRENT->mpattern); 

  if ((mstate==SHOOTING) && (mtime==10)) {
    mstate = NORMAL;
    Copy(alastspaceship);
  }
}

void LastSpaceShip::Fire1() {
  short i;
  SpriteElem *sprite;

  if (snd) Snd_effect(16,CHFOES2);

  for (i=0;i<=4;i++) {
    sprite = new LastSpaceShipFire1((ListSprite *)mlist,20);
    sprite->SetLocation(mx-640,my+160);
    sprite->SetDirection(-100,48-i*24);
    mlist->Add(sprite);
  }
  for (i=0;i<=3;i++) {
    sprite = new LastSpaceShipFire1((ListSprite *)mlist,20);
    sprite->SetLocation(mx-640,my+160);
    sprite->SetDirection(-80,36-i*24);
    mlist->Add(sprite);
  }
}
void LastSpaceShip::Fire2() {
  SpriteElem *sprite;
  short dir = mvarfire2 & 15;

  sprite = new LastSpaceShipFire2((ListSprite *)mlist,5);
  sprite->SetLocation(mx-640,my+160);
  sprite->SetDirection((dir-7)*16,((dir<8)?dir:16-dir)*16);
  mlist->Add(sprite);
  
  sprite = new LastSpaceShipFire2((ListSprite *)mlist,5);
  sprite->SetLocation(mx-640,my+160);
  sprite->SetDirection((dir-7)*16,-((dir<8)?dir:16-dir)*16);
  mlist->Add(sprite);
  
}




/* ------------------------ LastSpaceShip fire1 ----------------------------*/

LastSpaceShipFire1::LastSpaceShipFire1(ListSprite *list,short power) : LinearSprite(list) {
  mtype=LASTSPACESHIPFIRE1;
  mpower=power;
  ((ListSprite *)mlist)->mnombre[LASTSPACESHIPFIRE1]++;
  Copy(alastspaceshiptir1);
}

void LastSpaceShipFire1::ContactWith(Sprite *sp) {
  switch (sp->mtype) {   
  case MYSPACESHIP:
    Die();
    break;
  default:
    break;
  }
}


void LastSpaceShipFire1::Die() {
  mdy =- mdy;
}

/* ------------------------ LastSpaceShip fire2 ----------------------------*/

LastSpaceShipFire2::LastSpaceShipFire2(ListSprite *list,short power) : LinearSprite(list) {
  mtype=LASTSPACESHIPFIRE2;
  mpower=power;
  ((ListSprite *)mlist)->mnombre[LASTSPACESHIPFIRE2]++;
  Copy(alastspaceshiptir2);
}

void LastSpaceShipFire2::ContactWith(Sprite *sp) {
  switch (sp->mtype) {   
  case MYSPACESHIP:
    Die();
    break;
  default:
    break;
  }
}


void LastSpaceShipFire2::Die() {
  vie=0;
}
