/*
   List.h
   List contains Elem(s). 

   Xavier HOSXE
   */


#ifndef _LIST_
#define _LIST_

#include <stdlib.h>
#include "List.h"
#include "Elem.h"

class List {
  friend class Elem;	
public:
  Elem *mcurrent;
  Elem *mfirst;
  Elem *mlast;
  short mnumber;

  List(void) {
    mfirst=NULL;
    mlast=NULL;
    mcurrent=NULL;
    mnumber = 0;
  }

  void Copy(List *list) {
    mfirst=list->get_mfirst();
    mlast=list->get_mlast();
    mcurrent=mfirst;
  }
 
  Elem *get_mcurrent() {return mcurrent;}
  Elem *get_mfirst() {return mfirst; }  
  Elem *get_mlast() {return mlast;}  
  void Setmcurrent(Elem *n) {mcurrent = n;}
  void Add(Elem * el) {
    if (!mfirst) {
      mcurrent=mfirst=el;
    } else {
      mlast->mnext=el;
      el->mprev=mlast;
    }
    mlast=el;
    mnumber++;
  }

  short Next(void) {
    mcurrent=mcurrent->mnext;
    if (!mcurrent) {
      mcurrent=mfirst;
      return 0;
    } else {
      return 1;
    }
  }
  short Prev(void) {
    mcurrent=mcurrent->mprev;
    if (!mcurrent) {
      mcurrent=mlast;
      return 0; 
    } else {
      return 1;
    }
  }

  short First(void) {
    if (mfirst) {
      mcurrent=mfirst;
      return 1;
    } else {
      return 0;
    }
  }

  void DecMnumber() {mnumber--;}
  short get_mnumber() {return mnumber; }
};

#endif



