/*
   ListChoice.cc
   is a list of ChoiceElem

   Xavier HOSXE
*/


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <vga.h>
#include <vgagl.h>
#include <string.h>
#include "ListChoice.h"
#include "ChoiceElem.h"
#include "Sprite.h"
#include "cadre.h"
#include "SpaceShips.h"
#include "soundIt.h"
#include "Joystick.h"

#define XMENU 180
#define YMENU 15

extern short snd;



void ListChoice::Add(char *name) {
  ChoiceElem *nouveau;
  nouveau = new ChoiceElem(this,mcompt,name);
  List::Add((Elem *)nouveau);
  mcompt++;
  mlastchoice = 0;
}

void ListChoice::Display(short c) {
  short ecart = 150 / (mnumber-1);
  short i=0;
  
  gl_setfontcolors(0,132);
  gl_write(XMENU+206-strlen(mtitle)*4,YMENU+20,mtitle);

  if (First()) {
    do {
      if (((ChoiceElem *)mcurrent)->get_mnumber()==c){
	gl_setfontcolors(0,220);
      } else {
	gl_setfontcolors(0,81);
      }
      gl_write(XMENU+206-strlen(((ChoiceElem *)mcurrent)->get_mname())*4,YMENU+60+i*ecart,((ChoiceElem *)mcurrent)->get_mname());
      i++;
    } while (Next());
  }
  gl_copyscreen(gc_video);
}

short ListChoice::Ask() {
  short choice=mlastchoice;
  short old_pos=0;
  struct movement *js;

  usleep(150000);
  js = readJoystick(0);
  Display(choice);
  while (!js->b1) {
    js = readJoystick(0);
    if ((js->up) && (old_pos!=1)) {
      if (choice==0) {
	if (snd) Snd_effect(8,CHMISC);
	choice =mnumber-1;
	Display(choice);
      } else {
	if (snd) Snd_effect(8,CHMISC);
	choice--;
	Display(choice);
      }
      old_pos=1;
    } else if ((js->down) && (old_pos!=2)) {
      if (snd) Snd_effect(8,CHMISC);
      choice = (choice+1) % mnumber;
      Display(choice);
      old_pos=2;
    } else if ((!js->up) && (!js->down)) {
      old_pos=0;
    }
  }
  if (snd) { 
    Snd_effect(8,CHMISC);
  }
  usleep(150000);
  mlastchoice=choice;
  return choice;
}

Choice* ListChoice::Buttons(short n) {
  short i=0;

  if (First())
    do {
      if (i==n)
	return ((ChoiceElem *)mcurrent);
      i++;
    } while (Next());
  return NULL;
}
