/*
   ListSprite.cc
   This class is the higher one.
   It manages a list of SpriteElem
   
   Xavier HOSXE
*/

#include <stdlib.h>
#include "ListSprite.h"
#include "GraphElem.h"
#include "SpaceShips.h"
#include "Elem.h"

ListSprite::ListSprite(int n) {
  short k;
  mnombre = (short *)malloc(n*sizeof(short));
  mnumberoftype = n;
  for (k=0;k<n;k++)
    mnombre[k]=0;
}

void ListSprite::DrawSprites(void) {
  if (First()) {
    do {
      ((SpriteElem *)mcurrent)->Draw();
    } while (Next());
  }
}

void ListSprite::MoveSprites(void) {
  if (First()) {
    do {
      ((SpriteElem *)mcurrent)->Move();
    } while (Next());
  }
}

void ListSprite::Vide(void) {
  short k;
  Elem *next;

  if (First()) {
    do {
      next = mcurrent->GetNext();
      delete (((SpriteElem *)mcurrent));
      mcurrent = next;
    } while (mcurrent);
    for (k=0;k<mnumberoftype;k++)
      mnombre[k]=0;
    mfirst=NULL;
    mlast=NULL;
    mcurrent=NULL;
    mnumber = 0;
  }
}

void ListSprite::KillFeature(void) {
  if (First()) {
    do {
      switch (((SpriteElem *)mcurrent)->mtype) {
      case MYLAUNCHFIRE:
	((SpriteElem *)mcurrent)->tue();
      }
    } while (Next());
  }
}

#define MCURRENT ((SpriteElem *) mcurrent)
#define MCURRENT_ANIM ((GraphElem *)mcurrent)

void ListSprite::Interaction(void) {
  static SpriteElem *sp1;
  static short dx,dy,dcx,dcy;
  static Elem *next;

  if (First()) {
    do {
      sp1=MCURRENT;
      
      while ((mcurrent=MCURRENT->mnext)) 
	if (sp1->mtype!=MCURRENT->mtype) {
	  dx=(short)(MCURRENT->mx - sp1->mx);
	  dy=(short)(MCURRENT->my - sp1->my);
	  dcx=(short)(((GraphElem *)MCURRENT->mcurrent)->mxCenter+((GraphElem *)sp1->mcurrent)->mxCenter);
	  dcy=(short)(((GraphElem *)MCURRENT->mcurrent)->myCenter+((GraphElem *)sp1->mcurrent)->myCenter);
	  if (abs(dx)<abs(dcx))
	    if (abs(dy)<abs(dcy)) {
	      sp1->ContactWith(MCURRENT);
	      MCURRENT->ContactWith(sp1);
	    }
	} 
      Setmcurrent(sp1);
    }  while (Next());
  }
  if (First()) 
    do {
      next = mcurrent->GetNext();
      if (!MCURRENT->vie) {
	MCURRENT->RemoveMe();
	delete(MCURRENT);
      } 
      mcurrent = next;
    } while (mcurrent);
} 



