/*
   MoreSprites.cc
   Here are defined some often used function.

   Xavier HOSXE
*/

#include <stdio.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include "MoreSprites.h"
#include "GraphElem.h"
#include "sqrt.h"
#include "Joystick.h"

#define MCURRENT ((GraphElem *) mcurrent)
extern short fin;
extern short autofire;

/* ---------------- PingPong SPRITE --------------*/


PingPongSprite::PingPongSprite(ListSprite *list,short speed):SpriteElem(list) {
  mspeed=speed;
}

void PingPongSprite::Move() {
  Update(); // call Update for coordinates (of superclass MovingPoint)
     
  if (mx<=MCURRENT->mxCenter) {
    mx=MCURRENT->mxCenter;
    mdx=-mdx;
  } else if (mx>=WIDTH4-(MCURRENT->mwidth)+(MCURRENT->mxCenter)) {
     mx=WIDTH4-(MCURRENT->mwidth)+(MCURRENT->mxCenter);
    mdx=-mdx;
  }
  if (my<=PLAFOND+MCURRENT->myCenter) {
    my=PLAFOND+MCURRENT->myCenter;
    mdy=-mdy;
  } else if (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
    my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight;
    mdy=-mdy;
  }
} 

/* ---------------- Linear SPRITE --------------*/


LinearSprite::LinearSprite(ListSprite *list):SpriteElem(list) {
}

void LinearSprite::Move() {
  Update(); // call Update for coordinates (of superclass MovingPoint)
  
  if (((mx<=-MCURRENT->mxCenter) && (mdx<0)) || ((mx>=WIDTH4+(MCURRENT->mwidth)+(MCURRENT->mxCenter)) && (mdx>0))) {
    vie=0;
  } else if (((my+16)<PLAFOND+MCURRENT->myCenter)  || ((my-16)>HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight)) {
    Die();
  }
} 

void LinearSprite::Die() {
}



/* ---------------- Bouncing SPRITE --------------*/


BouncingSprite::BouncingSprite(ListSprite *list ,short p):SpriteElem(list) {
  mpoids = p;
}

void BouncingSprite::Move() {
  mdy += mpoids;
  
  Update();
  
  /*  if (((mx<=-MCURRENT->mxCenter) && (mdx<0)) || ((mx>=WIDTH4+(MCURRENT->mwidth)+(MCURRENT->mxCenter)) && (mdx>0))) {
      vie=0;
      } 
      */

  if (my<=PLAFOND+MCURRENT->myCenter) {
    my=PLAFOND+MCURRENT->myCenter;
    mdy=-mdy;
  } else if (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
    my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight;
    mdy=-mdy;
  }
  if ((((mdy>0)?mdy:-mdy)<1) && (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight))
    mdy=-15;

}  



/* ---------------- TraceSprite SPRITE --------------*/

TraceSprite::TraceSprite(ListSprite *list,SpriteElem *mw,short sp,float coef):SpriteElem(list) {
  mwhichone=mw;
  mspeed=sp;
  mcoef=coef;
}


void TraceSprite::Move() {
  static short tmpx,tmpy;
  static short v;
  if (!fin) {
    tmpx=(mwhichone->mx-mx)>>4 ;
    tmpy=(mwhichone->my-my)>>4 ;
    v=sqrtSoft((tmpx*tmpx+tmpy*tmpy)<<1);
    mdx=(short)((mdx+tmpx*mspeed/v)/mcoef);
    mdy=(short)((mdy+tmpy*mspeed/v)/mcoef);
  } else {
    mdy+=2;
    if ((my-16)>HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
      Die();
    }
  }
  Update(); 
}

void TraceSprite::Die() {
}

/* ---------------------- Joystick SPRITE ---------------*/


JoystickSprite::JoystickSprite(ListSprite *list,short sp):SpriteElem(list) {
  mspeed=sp;
}



void JoystickSprite::Move() {
  static short comptfire1=0;
  static struct movement *js;
  
  js = readJoystick(0);

  
  if (js->left)  {
    if (mdx>-0x50)
      mdx -= 0x10;
  } else if (js->right) {
    if (mdx<0x50)
      mdx += 0x10;
  } else {
    if (mdx<-0x10) {
      mdx+=0x10;
    } else if (mdx>0x10) {
      mdx-=0x10;
    } else {
      mdx=0;
    }
  }
  
  if (js->up) {
    if (mdy>-0x50)
      mdy -= 0x10;
  } else if (js->down) {
    if (mdy<0x40)
      mdy += 0x10;
  } else {
    if (mdy<-0x50) {
      mdy+=0x10;
    } else if (mdy>0x10) {
      mdy-=0x10;
    } else  {
      mdy=0;
    }
  }
  
  Update();

  if ((comptfire1++) == autofire) {
    comptfire1 = 0;
  }

  if (js->b1) {
    if (!comptfire1) {
      Fire1();
    } 
  }
  else {
    comptfire1=autofire-1; 
  }

  /*  if (js->b2) 
      Fire2();
      */

}

void JoystickSprite::Fire1() {
}

void JoystickSprite::Fire2() {
}


/* --------------- SPRING SPRITE -----------*/


SpringSprite::SpringSprite(ListSprite *list,short posx,short posy,short kx,short ky) : SpriteElem(list) {
  mposx=posx;
  mposy=posy;
  mkx=kx;
  mky=ky;
}

void SpringSprite::Move() {

  mdx -= ((mx-mposx)*mkx)>>8;
  mdy -= ((my-mposy)*mky)>>8; 
  
  Update();

}

/* --------------- FOLLOW SPRITE -----------*/

FollowingSprite::FollowingSprite(ListSprite *list,SpriteElem *whichone,short x,short y) : SpriteElem(list) {
  m_x=x<<4;
  m_y=y<<4;
  mwhichone=whichone;
}
  
void FollowingSprite::Move() {
  mx = mwhichone->mx+m_x;
  my = mwhichone->my+m_y;
}

void FollowingSprite::Draw() {
  SpriteElem::Draw();
  Prev();
}
