/*
   MoreSprites.cc
   Here are defined some often used function.

   Xavier HOSXE
*/


#ifndef _MORE_SPRITES_
#define _MORE_SPRITES_

#include "SpriteElem.h"
#include "ListSprite.h"



class PingPongSprite : public SpriteElem {
protected:
  short mspeed;
public:
  PingPongSprite(ListSprite *list,short speed);
  void Move();
};

class LinearSprite : public SpriteElem {
 public:
  LinearSprite(ListSprite *list);
  virtual void Move();
  virtual void Die();
};

class BouncingSprite : public SpriteElem {
protected:
  short mpoids;
public:
  BouncingSprite(ListSprite *list,short p);
  short get_mpoids() {return mpoids;}
  void Move();
};

class TraceSprite:public SpriteElem {
protected:
  float mcoef;
  short mspeed;
  SpriteElem *mwhichone;
public:
  TraceSprite(ListSprite *list,SpriteElem *mw,short sp,float mcoef);
  void set_mwhichone(SpriteElem *wo) {mwhichone = wo;}
  void Move();
  virtual void Die();
};

class FollowingSprite : public SpriteElem {
 protected:
  short m_x;
  short m_y;
  SpriteElem *mwhichone;
 public:
  FollowingSprite(ListSprite *list,SpriteElem *whichone,short x,short y);
  void Move();
  void Draw();
};

class JoystickSprite: public SpriteElem {
protected:
  short mspeed;
  short mmaxfire;
  short mjoy;
public:
  JoystickSprite(ListSprite *list,short sp); 
  void Move(void);
  virtual void Fire1();
  virtual void Fire2();
};

class SpringSprite: public SpriteElem {
protected:
  short mspeed;
  short mposx,mposy; // position of the center
  short mkx,mky;     // stiffness
public:
  SpringSprite(ListSprite *list,short posx,
	       short posy,short kx,short ky);
  void Move(void);
};

#endif





