/* 
   NEWSPACESHIPS'Sprites
   Interactions, animations, etc...
   are defined here !

   Xavier HOSXE
  
   May & June 1996
 */


#include <stdio.h>
#include <stdlib.h>
#include <ListSprite.h>
#include <string.h>
#include "SpaceShips.h"
#include "NewSpaceShips.h"

extern int highScore;
extern short level,often,snd;
extern char *TopBar;
extern char *BottomBar;



/* -------------- LARGUEUR ---------------------- */


Largueur::Largueur(ListSprite *list,short power,short fireoften) : LinearSprite(list) {
  mtype=LARGUEUR;
  Copy(alargueur);
  mfireoften=fireoften;
  mpower=power;
  ((ListSprite *)list)->mnombre[LARGUEUR]++;
  manim=0;
}


#define MCURRENT ((GraphElem *) mcurrent)

void Largueur::Draw() {
  manim=(manim+1)&3; 
  gl_putboxmask((-MCURRENT->mxCenter+mx)>>4,
                ((-MCURRENT->myCenter+my)>>4)+(pageFlipping[!page]),
                MCURRENT->mwidth>>4,
                MCURRENT->mheight>>4,
                MCURRENT->mpattern);
  
  if (!manim)
    Next();
}

void Largueur::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    Die();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
      if (mpower<=0) {
	Die();
	((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(400);
      }
      break;
  default:
    break;
  }
}

void Largueur::Move(){
  LinearSprite::Move();
  
  if ((!(random() & (mfireoften-1))) && (!fin) && (mtype==LARGUEUR))
    Fire();
}

void Largueur::Fire() {
  LargueurFire *sp;
  
  sp = new LargueurFire((ListSprite *)mlist,2,10);
  sp->SetLocation(mx,my+320);
  sp->SetDirection(0,8);
  mlist->Add(sp);  
}


void Largueur::Die(){
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(alargueurexplosion);
  ex->SetLocation(mx,my-8);
  ex->SetDirection(mdx>>2,8);
  mlist->Add(ex);
  vie=0;
  if (snd)  Snd_effect(10,CHFOES1);
}

/* --------- Largueur Fire ------- */

LargueurFire::LargueurFire(ListSprite *list,short speed,short power) : LinearSprite(list) {
  mtype=LARGUEURFIRE;
  mspeed = speed;
  mpower = power;
  Copy(alargueurfire);
  ((ListSprite *)mlist)->mnombre[LARGUEURFIRE]++;
}

void LargueurFire::ContactWith(Sprite *sp) {
  switch (sp->mtype) {   
  case BALL:
    SetDirection((mdx>>1)+((mx-sp->mx)>>2),(my-sp->my)>>2);
    break;
  case MYFIRE:
  case MYSPACESHIP:
    Die();
    break;
  default:
    break;
  }
}

void LargueurFire::Move() {
  mdy += mspeed;
  LinearSprite::Move();
 
}

void LargueurFire::Die() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(alargueurfireexplosion);
  if (snd) Snd_effect(12,CHFOES2);

  mlist->Add(ex);
  vie=0;
}

/* ---------- Asteroid ---------------- */


Asteroid::Asteroid(ListSprite *list,int power) : LinearSprite(list) {
  mpower = power;
  mtype=ASTEROID;
  Copy(aasteroid);
  ((ListSprite *)list)->mnombre[ASTEROID]++;
}

void Asteroid::Draw() {
  LinearSprite::Draw();
  mcurrent = mfirst;
}


void Asteroid::Explose() {
  static Explosion *ex;
  static SpriteElem *sp;
  int i,randx,randy,nbre;

  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aasteroid);
  ex->SetDirection(mdx,mdy);
  mlist->Add(ex);
  vie=0;  
  if (snd) Snd_effect(4,CHFOES1);
  nbre = (random() & 3) +3;
  for (i=0;i<nbre;i++) {
    randx = ((random() & 15) -9)*8;
    randy = ((random() & 15) -7)*8;
    sp = new Meteor((ListSprite *)mlist,random() & 1);
    sp -> SetLocation(mx,my);
    sp -> SetDirection(randx,randy);
    mlist->Add(sp);
    sp -> Update();
  }
}

void Asteroid::Die() {
  mdy=-mdy;
}

void Asteroid::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(50);
    Explose();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (mpower<=0) {
      Explose();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(200);
    }
    break;
  case METEOR:
    if (vie) Explose();
    break;
  default:  
    break;
  }
}

/* ---------------------- Meteor ----------------- */

Meteor::Meteor(ListSprite *list,int one) : LinearSprite(list) {
  mpower = (random() & 3) * 10 +20;
  mtype=METEOR;
  
  if (one ==1) {
    Copy(ameteor1);
  } else {
    Copy(ameteor2);
  }
  mone=one;
  ((ListSprite *)list)->mnombre[METEOR]++;
}

void Meteor::Explose() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  if (mone==1) {
    ex->Copy(ameteor1explosion);
  } else {
    ex->Copy(ameteor2explosion);
  }
  mlist->Add(ex);
  vie=0;  
  if (snd) Snd_effect(4,CHFOES1);
}

void Meteor::Die() {
  mdy =-mdy;
}

void Meteor::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(20);
    Explose();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (mpower<=0) {
      Explose();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(20);
    }
    break;
  default:  
    break;
  }
}


/* ---------------------- Plane (parent of plane 1 2 3 4 5) ----------------- */

Plane::Plane(ListSprite *list) : LinearSprite(list) {
  mtype=PLANE;
  ((ListSprite *)list)->mnombre[PLANE]++;
  // No Copy() (defined in children)
  mstate =0;
  mpower = 10;
}

void Plane::Explose() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aplaneexplosion);
  ex->SetDirection(mdx,mdy);
  mlist->Add(ex);
  vie=0;  
  if (snd) Snd_effect(4,CHFOES1);
}

void Plane::Die() {
  mdy=-mdy;
}

void Plane::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(20);
    Explose();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (mpower<=0) {
      Explose();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(100);
    }
    break;
  default:  
    break;
  }
}



/* -------------- Different movements of planes ----------------- */


// Plane 1  : Real Linear Sprite

void Plane2::Move() {
  switch (mstate) {
  case 0:
    if (mx < 4000) { 
      // 4000 = 250 * 16
      mstate = 1;
    }
    break;
  case 1:
    mdx +=4;
    if (mdx>80) {
      mdx=80;
    }
    if (mx > 6400) {
      // 64 = 400 * 16 ;
      mstate =2;
    }
    break;
  case 2:
    mdx -=4;
    if (mdx<-80) {
      mdx = -80;
    }
    break;
  default:
    break;
  }

  LinearSprite::Move();
  
}


void Plane3::Move() {

  if (mx>((SpriteElem *)mlist->mfirst)->mx) {
    mdy = (((SpriteElem *)mlist->mfirst)->my-my)/150*mspeed;  
  } else {
    if (mdy>16) mdy -=8;
    if (mdy<-16) mdy+=8;
  }
  LinearSprite::Move();
}

void Plane4::Move() {
  switch (mstate) {
  case 0:
    if (mx < 4000) { 
      // 4000 = 250 * 16
      mstate = 1;
    }
    break;
  case 1:
    mdx +=4;
    if (mdx>80) {
      mdx=80;
    }
    if (mx > 6400) {
      // 64 = 400 * 16 ;
      mstate =2;
    }
    break;
  case 2:
    mdx -=4;
    if (mdx<-80) {
      mdx = -80;
    }
    break;
  default:
    break;
  }
  if (mx>((SpriteElem *)mlist->mfirst)->mx) {
    mdy = (((SpriteElem *)mlist->mfirst)->my-my)/150*mspeed;  
  } else {
    if (mdy>16) mdy -=8;
    if (mdy<-16) mdy+=8;
  }
  LinearSprite::Move();
}

void Plane5::Move() {
  LinearSprite::Move();
}


/* --------- Flying Tower ----------- */


Ftower::Ftower(ListSprite *list,int power) : LinearSprite(list) {
  mpower=power;
  mtype=FTOWER;
  ((ListSprite *)list)->mnombre[FTOWER]++;
  Copy(aftower);
  mstate =0;
  mx = 680<<4;
  my = ((random() & 255) +120)<<4;
  mstate = 0;
}

void Ftower::Explose() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aftowerexplosion);
  ex->SetDirection(mdx>>1,mdy>>1);
  mlist->Add(ex);
  vie=0;  
  if (snd) Snd_effect(4,CHFOES1);
}

void Ftower::Die() {
  mdy=-mdy;
}

void Ftower::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(20);
    Explose();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (mpower<=0) {
      Explose();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(200);
    }
    break;
  default:  
    break;
  }
}

void Ftower::Move() {
  switch(mstate) {
  case 0:
    mdx =-16;
    LinearSprite::Move();
    if (!(random() & (16*often-1))) {
      Fire();
    }
    break;
  default:
    break;
  }
}


void Ftower::Fire() {
  static SpriteElem *tir;

  tir=new FtowerFire((ListSprite *)mlist);
  tir->SetLocation(mx,my);
  tir->SetDirection(-80,((random() & 31)-15)); 
  mlist->Add(tir); 
}
  


/* ------ Flying Tower fire ------ */


FtowerFire::FtowerFire(ListSprite *list): LinearSprite(list) {
  mtype=FTOWERFIRE;
  ((ListSprite *)list)->mnombre[FTOWERFIRE]++;
  Copy(aftowerfire);
}

void FtowerFire::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    vie=0;
    break;
  case MYFIRE:
    mx +=64;
    break;
  default:
    break;
  }
};
  
void FtowerFire::Die() {
  vie=0;
}


/* ---- Big Turning Space Ship ----- */

Bigturning::Bigturning(ListSprite *list ,int power ,int fireoften,int center ) : SpriteElem (list) {
  mtype=BIGTURNING;
  ((ListSprite *)list)->mnombre[BIGTURNING]++;
  mpower = power;
  mfireoften = fireoften;
  Copy(abigturning); 
  mstate = 0;
  mcenter = center;
}

void Bigturning::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(20);
    Explose();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (mpower<=0) {
      Explose();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(200);
    }
    break;
  default:
    break;
  }
}


void Bigturning::Explose() {
  Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(abigturningexplosion);
  ex->SetDirection(mdx>>1,mdy>>1);
  mlist->Add(ex);
  vie=0;  
  if (snd) Snd_effect(4,CHFOES1);
}
 
void Bigturning::Move() {
  if (my >mcenter) 
    mdy-=8;
  if (my < mcenter) 
    mdy+=8;
  Update();

  if (((mx<=-MCURRENT->mxCenter) && (mdx<0)) || ((mx>=WIDTH4+(MCURRENT->mwidth)+(MCURRENT->mxCenter)) && (mdx>0))) {
    vie=0;
  } 


  if (!(random() & (mfireoften-1))) {
    mstate = 1;
  }
  if (mstate) {
    Fire();
  }
}

void Bigturning::Fire() {
  EnemyFire *sp;
  
  if (mstate & 1) {
    sp = new EnemyFire((ListSprite *)mlist,10,5);
    sp->Copy(abigturningfire);
    
    sp->SetLocation(mx-320,my);
    sp->SetDirection(-0x80,(random() & 31) - 16);
    mlist->Add(sp);  
  }    
  
  mstate++;
  if (mstate==8) {
    mstate=0;
  }
}
