/* 
   NEWSPACESHIPS'Sprites
   Interactions, animations, etc...
   are defined here !

   Xavier HOSXE
  
   may 1996
 */


#ifndef _NEWSPACESHIPS_
#define _NEWSPACESHIPS_

#include "MoreSprites.h"
#include "soundIt.h"
#include "GraphElem.h"
#include "ListSprite.h"


class Largueur : public LinearSprite {
 protected:
  short mfireoften;
  short mpower;
  short manim;
 public:
  Largueur(ListSprite *list,short,short );
  void ContactWith(Sprite *sp);
  void Move();
  void Fire();
  void Die();
  void Draw();
};

class LargueurFire : public LinearSprite {
protected:
  short mspeed;
public:
  short mpower;
  LargueurFire(ListSprite *list,short speed,short power);
  void ContactWith(Sprite *sp);
  void Die();
  void Move();
};

class Asteroid: public LinearSprite {
protected:
  int mpower;
 public:
  Asteroid(ListSprite *sp,int power);
  void ContactWith(Sprite *sp);
  void Die();
  void Explose();
  void Draw();
};

class Meteor: public LinearSprite {
protected:
  int mpower;
  int mone;
public:
  Meteor(ListSprite *,int);
  void ContactWith(Sprite *sp);
  void Die();
  void Explose();
};

class Plane: public LinearSprite {
protected:
  int mstate;
  int mpower;
public:
  Plane(ListSprite *sp);
  void ContactWith(Sprite *sp);
  void Die();
  void Explose();
};

class Plane1: public Plane {
public:
  Plane1(ListSprite *sp) : Plane(sp) {
    Copy(aplane1);
  }
};

class Plane2: public Plane {
public:
  Plane2(ListSprite *sp) : Plane(sp) {
    Copy(aplane2);
  }
  void Move();
};

class Plane3: public Plane {
protected:
  int mspeed;
public:
  Plane3(ListSprite *sp) : Plane(sp) {
    Copy(aplane3);
    mspeed = (random() & 3);
  }
  void Move();
};

class Plane4: public Plane {
protected:
  int mspeed;
public:
  Plane4(ListSprite *sp) : Plane(sp) {
    Copy(aplane4);
    mspeed = 2 + (random() & 3);
  }
  void Move();
};

class Plane5: public Plane {
public:
  Plane5(ListSprite *sp) : Plane(sp) {
    Copy(aplane5);
  }
  void Move();
};

class Ftower: public LinearSprite {
protected:
  int mstate;
  int mpower;
public:
  Ftower(ListSprite *,int);
  void ContactWith(Sprite *sp);
  void Die();
  void Explose();
  void Move();
  void Fire();
};


class FtowerFire : public LinearSprite {
public:
  FtowerFire(ListSprite *);
  void ContactWith(Sprite *);
  void Die();
};

class Bigturning: public SpriteElem {
protected:
  int mstate;
  int mpower;
  int mfireoften;
  int mcenter;
public:
  Bigturning(ListSprite *,int,int,int);
  void ContactWith(Sprite *sp);
  void Explose();
  void Move();
  void Fire();
};




#endif

