/* 
   SPACESHIPS'Sprites
   Interactions, animations, etc...
   are defined here !

   Xavier HOSXE
   */


#include <stdio.h>
#include <stdlib.h>
#include <ListSprite.h>
#include <string.h>
#include "SpaceShips.h"
#include "NewSpaceShips.h"
#include "LastSpaceShip.h"
#include "sqrt.h"


#define MCURRENT ((GraphElem *) mcurrent)


extern short fin;
extern int highScore;
extern short level,often,snd;
extern void restore_all(int);


/* -------------------- MY SPACE SHIP -------------------------*/

extern int actualScore;
extern int actualPower;

MySpaceShip::MySpaceShip(ListSprite *list,short power,short speed,short firespeed,short firepower):JoystickSprite(list,speed) {

  mtype=MYSPACESHIP;
  SetPower();
  mfirespeed=firespeed;
  mfirepower=firepower;
  mcote=1;
  SetScore();
  mmyfire=0;
  mwhitetime=0;
  mwin=0;
  mtimer=0;
}

void MySpaceShip::Move() {
  if (!mwin) {
    JoystickSprite::Move();
    if (mx<=MCURRENT->mxCenter) {
      mx=MCURRENT->mxCenter;
      mdx=0;
    } else if (mx>=WIDTH4-(MCURRENT->mwidth)+(MCURRENT->mxCenter)) {
      mx=WIDTH4-(MCURRENT->mwidth)+(MCURRENT->mxCenter);
      mdx=0;
    }
    if (my<=PLAFOND+MCURRENT->myCenter) {
      my=PLAFOND+MCURRENT->myCenter;
      mdy=0;
    } else if ((my+((mmyfire & 4)?48:0))>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
      my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight-((mmyfire & 4)?48:0);
      mdy=0;
    }    
  } else if (mwin==1) {
    mtimer=0;
    mwin=2;
    actualPower = mpower;
  } else if (mwin==2) {
    mtimer++;
    if (mtimer>30) mwin=3;	
  } else if (mwin==3) {
    short tmpx,tmpy;
    short v;
    
    tmpx = (400-(mx>>2));
    tmpy = (800-(my>>2));
    v    = sqrtSoft(tmpx*tmpx+tmpy*tmpy);
    SetDirection((short)(tmpx*8/v)<<1,(short)(tmpy*8/v)<<1);	
    //	printf("----> (%i %i)\n",(short)(tmpx*8/v)<<3,(short)(tmpy*8/v)<<3);
    
    mwin=4;
  } else if (mwin==4) {
    Update();
    if (((((mx>>4)-100)*((mx>>4)-100))<900) && ((((my>>4)-200)*((my>>4)-200))<900)) {
      mwin=5;
      SetDirection(0,0);	
    }
  } else if (mwin==5) {
    mdx += 4;
    Update();
    if (mx>(700<<4)) {
      SetDirection(0,0);
      mwin=6;
    }
  } else if (mwin==6) {
    mtimer=0;
    mwin=7;
  } else if (mwin==7) {
    mtimer++;  
    if (mtimer>20) mwin=8;	
  } else if (mwin==8) {
    if (mpower>0) {
      mpower -=1;
      IncScore(100);
    } else {
      mwin=9;
    }
  }
  
  DisplPower();
  DisplScore();
  if (mwhitetime)
    if (mwhitetime++==3) {
      gl_setpalettecolor(0,0,0,0);
      mwhitetime=0;
    }   
}

void MySpaceShip::Fire1() {
  static SpriteElem *tir;

  tir=new MyFire ((ListSprite *)mlist,this,mfirespeed,mfirepower);
  tir->Copy(amyfire);
  tir->SetLocation(mx+320,my+48);
  tir->SetDirection(200+(mdx>>3),(mdy>>1)); 
  mlist->Add(tir); 
  if (mmyfire)
    LaunchMyFire();
  if (snd) Snd_effect(0,CHMYFIRE);
}

void MySpaceShip::LaunchMyFire() {
  static SpriteElem *tir;

  if (mmyfire & 1) {
    tir=new MyFire((ListSprite *)mlist,this,mfirespeed,mfirepower);
    tir->Copy(amyfire);
    tir->SetLocation(mx,my-0xf0);
    tir->SetDirection(180+(mdx>>3),(mdy>>1)-50);
    mlist->Add(tir); 
  }

  if (mmyfire & 2) {
    tir=new MyFire((ListSprite *)mlist,this,mfirespeed,mfirepower);
    tir->Copy(amyfire);
    tir->SetLocation(mx+352,my+80);
    tir->SetDirection(180+(mdx>>3),(mdy>>1)+50);
    mlist->Add(tir); 
  }

  if (mmyfire & 4) {   
    tir=new MyFire((ListSprite *)mlist,this,mfirespeed,mfirepower);
    ((MyFire *)tir)->BackFire();
    tir->Copy(abackfire);
    tir->SetLocation(mx-352,my+0xa0);
    tir->SetDirection(-160+(mdx>>3),(mdy>>1));
    mlist->Add(tir);   
  }
}

void MySpaceShip::Fire2() {
}

void MySpaceShip::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case FTOWER:
    DecPower(15);
  case ENEMY2:
    SetDirection((mx-(sp->mx) >>3),(my-sp->my) >>3);
    DecPower(5);
    if (snd) Snd_effect(5,CHMYSPACESHIP);
    break;
  case POWERUP:
    IncPower(50);
    break;
  case LASTSPACESHIP:
    if (((LastSpaceShip *)sp)->get_mstate()==FINALEXPLOSION) {
      break;
    }
    DecPower(20);
  case BALL:
  case LASTSPACESHIPFIRE1:
  case ENEMY2DEAD:
    DecPower(5);
    SetDirection((mx-sp->mx) >>2,(my-sp->my) >>2);
    if (snd) Snd_effect(5,CHMYSPACESHIP);
    break;
  case LASTSPACESHIPFIRE2:
    DecPower(10);
    if (snd) Snd_effect(5,CHMYSPACESHIP);
    break;
  case ENEMY3FIRE:
  case ENEMY1FIRE:
    DecPower(3);
    if (snd) Snd_effect(5,CHMYSPACESHIP);
    break;
  case LARGUEURFIRE:
    DecPower(5);
    SetDirection(mdx,(my-sp->my) );
    if (snd) Snd_effect(5,CHMYSPACESHIP);
    break;
  case MINE:
  case ENEMY1:
  case ENEMY3:
  case LARGUEUR:
  case FTOWERFIRE:
    SetDirection((mx-sp->mx) >>2,(my-sp->my) >>2);
    DecPower(20);
    break;
  case WALL:
    if (snd) Snd_effect(6,CHMYSPACESHIP);
    if ((my>(sp->my-((GraphElem *)sp->mcurrent)->myCenter)) && (my<(sp->my+((GraphElem *)sp->mcurrent)->myCenter)))
      SetDirection((mx>sp->mx)?64:-128,0);
    if ((mx>(sp->mx-((GraphElem *)sp->mcurrent)->mxCenter)) && (mx<(sp->mx+((GraphElem *)sp->mcurrent)->mxCenter)))
      SetDirection(0,(my>sp->my)?96:-96);
    DecPower(1);
    break;
  case FEATURE:
    set_mmyfire(((Feature *)sp)->get_mwhichfeature());
    break;
    
  default:
    break;
  }
}


void MySpaceShip::set_mmyfire(short m) { 
  SpriteElem *sp;

  if (m==0) {
    mmyfire = 0;
    myfire = 0;
    return;
  }

  if ((m & 1) && (!(mmyfire & 1))) {
    sp = new MyLaunchFire((ListSprite *)mlist,this,1);
    mlist->Add(sp);
    mmyfire += 1;  
    myfire = mmyfire;
  }

  if ((m & 2) && (!(mmyfire & 2))) {
    sp = new MyLaunchFire((ListSprite *)mlist,this,2);
    mlist->Add(sp);
    mmyfire += 2;  
  }

  if ((m & 4) && (!(mmyfire & 4))) {
    sp = new MyLaunchFire((ListSprite *)mlist,this,4);
    mlist->Add(sp);
    mmyfire += 4;  
  }

  myfire = mmyfire;
}


 void MySpaceShip::SetPower() {
   mpower=200;
   moldpower[0] = 0;
   moldpower[1] = 0;
   DisplPower();
 }

void MySpaceShip::IncPower(short i) {
  mpower=((mpower+i>200)?200:mpower+i);
}

void MySpaceShip::DecPower(short i) {
  mpower=((mpower-i-(level-1)*5)<0?0:mpower-i-(level-1)*3);
  gl_setpalettecolor(0,63,63,63);
  mwhitetime = 1;
}

void MySpaceShip::DisplPower() {
  if (mpower!=moldpower[!page]) {
    gl_disableclipping();
    if (mpower>moldpower[!page]) { 
      gl_fillbox((short)(71+moldpower[!page]*2.5),451+(pageFlipping[!page]),(short)((mpower-moldpower[!page])*2.5+.5),18,3);
    } else if (mpower<moldpower[!page]) {
      gl_fillbox((short)(71+mpower*2.5),451+(pageFlipping[!page]),(short)((moldpower[!page]-mpower)*2.5+.5),18,4);
      if (!mpower) {
	moldpower[!page]=mpower;  
	//	printf(" power : %i %i \n",moldpower[page],moldpower[!page]);
	if ((!moldpower[page]) && (!moldpower[!page]))
	  Die();
      }
    }
    moldpower[!page]=mpower;  
  }
}


void MySpaceShip::SetScore() {
  moldscore[0] = 0;
  moldscore[1] = 0;
  mscore=0;
 }

void MySpaceShip::IncScore(short i) {
   mscore=mscore+(i*level);
 }


void MySpaceShip::DisplScore() {
  static char charscore[6];
  static int oldHighScore[] = {highScore,highScore};

  if (mscore!=moldscore[!page]) {
    sprintf(charscore,"%i",mscore);
    gl_setfontcolors(22,30);
    gl_write(151+8*(6-strlen(charscore)),40+(pageFlipping[!page]),charscore);
    moldscore[!page]=mscore;  
    if (mscore>oldHighScore[!page]) {
      highScore = mscore;
      gl_setfontcolors(22,10);
      sprintf(charscore,"%i",mscore);
      gl_write(151+130+8*(6-strlen(charscore)),40+(pageFlipping[!page]),charscore);
      oldHighScore[!page] = mscore;
    }
  }
 
}

  
  
void MySpaceShip::Die() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(amyspaceshipexplosion);
  mlist->Add(ex);
  vie=0;  
  fin=1;
  ((ListSprite *)mlist)->KillFeature();
  if ((snd) && (!mwin)) Snd_effect(14,CHMISC);
  actualScore = mscore;
} 


void MySpaceShip::Win() {
  mwin=1;
}


void MySpaceShip::Draw() {
  JoystickSprite::Draw();
  Prev();
}

void MySpaceShip::set_mpower(short power) { 
  mpower = power; 
  DisplPower();
  page =! page;
  DisplPower();
  page =! page;
}



/* ------------------------ MyFire ----------------------------*/

MyFire::MyFire(ListSprite *list,MySpaceShip *fromwho,short speed,short power) : LinearSprite(list) {
  mpoids=0;
  mtype=MYFIRE;
  mpower=power;
  ((ListSprite *)mlist)->mnombre[MYFIRE]++;
  mfromwho=fromwho;
  backfire=0;
}


void MyFire::Draw() {
  if (!backfire) {
    gl_putboxmask((mx-8)>>4,
		  ((my-3)>>4)+(pageFlipping[!page]),
		  8,
		  4,
		  MCURRENT->mpattern); 
  } else {
    gl_putboxmask((mx-8)>>4,
		  ((my-3)>>4)+(pageFlipping[!page]),
		  4,
		  4,
		  MCURRENT->mpattern); 
  }
  Next();
}

void MyFire::BackFire() {
  backfire=1;
}


void MyFire::ContactWith(Sprite *sp) {
  switch (sp->mtype) {   
  case BALL:
    SetDirection((mdx>>2)+((mx-sp->mx) >>3),(my-sp->my) >>2);
    mpoids=4;
    break;
  case EXPLOSION:    
    break;
  default:
    Die();
    break;
  }
}

void MyFire::Move(void) {
  mdy+=mpoids;
  LinearSprite::Move();
}

MySpaceShip* MyFire::get_mfromwho() {
  return(mfromwho);
}

void MyFire::Die() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(amyfireexplosion);
  mlist->Add(ex);
  vie=0;
}

/* ---------------------- Ball ----------------- */

Ball::Ball(ListSprite *list) : LinearSprite(list) {
  mtype=BALL;
  Copy(aball);
  ((ListSprite *)list)->mnombre[BALL]++;
}

void Ball::Die() {
  if (my<=PLAFOND+MCURRENT->myCenter) {
    mdy = -mdy;
    my=PLAFOND+MCURRENT->myCenter;
  } else if (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
    mdy=-mdy;
    my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight;
  }
}

void Ball::ContactWith(Sprite *sp) {
  if (sp->mtype==WALL)
    mdx=-mdx;
}

/* ---------------------- Enemy1 ----------------- */

Enemy1::Enemy1(ListSprite *list,short posx,short posy,short kx,short ky,short fireoften, short firespeed,short power):SpringSprite(list,posx,posy,kx,ky) {
  mtype=ENEMY1CREATION;
  mpower=power;
  mfirespeed=firespeed;
  mfireoften=fireoften;
  ((ListSprite *)mlist)->mnombre[ENEMY1]++;
  Copy(aenemy1creation);
  if (snd) Snd_effect(2,CHFOES2);
}

void Enemy1::Draw() {

  Sprite::Draw();
  
  if ((MCURRENT==mfirst) && (mtype==ENEMY1CREATION)) {
    mtype=ENEMY1;
    Copy(aenemy1);
  }
}

void Enemy1::Move() {
  if (mtype==ENEMY1) {
    SpringSprite::Move();
    if ((!(random() & (mfireoften-1))) && (!fin))
      Fire();
  }
}


void Enemy1::Fire() {
  EnemyFire *sp;
  short tmpx,tmpy;
  short v;
  
  sp = new EnemyFire((ListSprite *)mlist,10,5);

  sp->SetLocation(mx,my);
  tmpx = (((SpriteElem *)mlist->mfirst)->mx-mx)>>4;
  tmpy = (((SpriteElem *)mlist->mfirst)->my-my)>>4;
  v    = sqrtSoft(tmpx*tmpx+tmpy*tmpy);
  sp->SetDirection((short)(tmpx*mfirespeed/v)<<3,(short)(tmpy*mfirespeed/v)<<3);
  sp->Copy(aenemy1fire);
  mlist->Add(sp);
}

void Enemy1::ContactWith(Sprite *sp) {
  if (mtype==ENEMY1) {
    switch (sp->mtype) {
    case MYSPACESHIP:
      Die();
      break;
    case MYFIRE:
      mpower -= ((MyFire *)sp)->mpower;
      if (mpower<=0) {
	Die();
	((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(100);
      }
      break;
    default:
      break;
    }
  }
}


void Enemy1::Die() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aenemy1explosion);
  mlist->Add(ex);
  vie=0;
  if (snd) Snd_effect(3,CHFOES1);
}

/* -------------------- ENEMY3 ------------------------------- */

Enemy3::Enemy3(ListSprite *list,short power,short fireoften) : LinearSprite(list) {
  mtype=ENEMY3;
  Copy(aenemy3);
  mfireoften=fireoften;
  mpower=power;
  ((ListSprite *)list)->mnombre[ENEMY3]++;
  manim=0;
}

void Enemy3::Draw() {

  manim=(manim+1)&1; 
  gl_putboxmask((-MCURRENT->mxCenter+mx)>>4,
                ((-MCURRENT->myCenter+my)>>4)+(pageFlipping[!page]),
                MCURRENT->mwidth>>4,
                MCURRENT->mheight>>4,
                MCURRENT->mpattern);
  
  if (!manim)
    Next();
}

void Enemy3::ContactWith(Sprite *sp) {
  if (mtype==ENEMY3) {
    switch (sp->mtype) {
    case MYSPACESHIP:
      Die();
      break;
    case MYFIRE:
      mpower -= ((MyFire *)sp)->mpower;
      if (mpower<=0) {
	Die();
	((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(400);
      }
      break;
    default:
      break;
    }
  }
}

void Enemy3::Move(){
  LinearSprite::Move();
  if ((!(random() & (mfireoften-1))) && (!fin) && (mtype==ENEMY3))
    Fire();
}

void Enemy3::Fire() {
  Enemy3Fire *sp;
  
  sp = new Enemy3Fire((ListSprite *)mlist,(SpriteElem *)mlist->mfirst, 8+(random() & 7));
  sp->SetLocation(mx+0xc0,my-320);
  sp->SetDirection(0,-0x80);
  mlist->Add(sp);  
}


void Enemy3::Die(){
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aenemy3explosion);
  ex->SetLocation(mx,my-8);
  mlist->Add(ex);
  vie =0;
  if (snd) Snd_effect(3,CHFOES1);
}


/*- --------------------- ENEMY 3 FIRE ---------------------*/ 

Enemy3Fire::Enemy3Fire(ListSprite *list,SpriteElem *mw,short speed) : TraceSprite (list,mw,speed,1.1) {
  short i;
  mtype= ENEMY3FIRE;
  Copy(aenemy3fire);
  ((ListSprite *)mlist)->mnombre[ENEMY3FIRE]++;
  First();
  for (i=0;i<8;i++) {
    mpos[i]=((GraphElem *)mcurrent)->mpattern;
    Next();
  }
}

void Enemy3Fire::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case BALL:
    SetDirection((mdx>>2)+((mx-sp->mx)>>3),(my-sp->my)>>2);
    break;
  case MYFIRE:
    ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(10);
    Die();
    break;
  case ENEMY3FIRE:
  case MYSPACESHIP:
    Die();
    break;
  default:
    break;
  }
}

char* Enemy3Fire::GoodPattern() {
  short i;
  
  if (mdy==0) {
    if (mdx>=0) i=2; else i=6;
  } else if (mdx==0) {
    if (mdy<=0) i=0; else i=4;
  } else if ((mdx/mdy>5) || (mdx/mdy<-5)) {
    if (mdx>=0) i=2; else i=6;
  } else if ((mdy/mdx>5) || (mdy/mdx<-5)) {
    if (mdy>=0) i=0; else i=4;
  } else if (mdx>0) {
    i=(2+((mdy>0)?1:-1));
  } else {
    i=(6+((mdy>0)?-1:1));
  }
  return mpos[i]; 
}

void Enemy3Fire::Draw() {
   gl_putboxmask((-MCURRENT->mxCenter+mx)>>4,
                ((-MCURRENT->myCenter+my)>>4)+(pageFlipping[!page]),
                MCURRENT->mwidth>>4,
                MCURRENT->mheight>>4,
                GoodPattern());
 }  

void Enemy3Fire::Move() {
  TraceSprite::Move();
  if (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
    my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight;
    Die();
  }
}

void Enemy3Fire::Die() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aenemy3fireexplosion);
  mlist->Add(ex);
  vie=0;
}

/* ------------------------ Enemy (1 et 2) Fire ----------------------------*/

EnemyFire::EnemyFire(ListSprite *list,short speed,short power) : LinearSprite(list) {
  mtype=ENEMY1FIRE;
  mpower=power;
  ((ListSprite *)mlist)->mnombre[ENEMY1FIRE]++;
}

void EnemyFire::ContactWith(Sprite *sp) {
  switch (sp->mtype) {   
  case BALL:
    SetDirection((mdx>>1)+((mx-sp->mx)>>2),(my-sp->my)>>2);
    break;
  case MYFIRE:
  case MYSPACESHIP:
    Die();
    break;
  default:
    break;
  }
}


void EnemyFire::Die() {
  vie=0;
}


/* ---------------- MINE --------------------------*/

Mine::Mine(ListSprite *list,SpriteElem *mw,short speed,short power) : TraceSprite(list,mw,speed,1.1) {
  mtype=MINE;
  mpower=power;
  ((ListSprite *)mlist)->mnombre[MINE]++;
  Copy(amine);
}


void Mine::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    Die();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    SetDirection((mdx+((MyFire *)sp)->mpower*((sp->mdx>0)?4:-4)),(my-sp->my)>>2);
    
    if (mpower<=0) {
      Die();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(300);
    }
    break;
  default:
    break;
  }
}

void Mine::Die() {
  static Explosion *ex;
  
  if (snd) Snd_effect(9,CHFOES1);
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(amineexplosion);
  mlist->Add(ex);
  vie=0;
}


/* ------------------------ ENEMY2 ----------------------------*/

Enemy2::Enemy2(ListSprite *list,SpriteElem *mw,short fireoften,short power,short p) : BouncingSprite(list, p) {
  Copy(aenemy2);
  mwhich = mw;
  mtype=ENEMY2;
  mpower=power;
  mfireoften=fireoften;
  ((ListSprite *)mlist)->mnombre[ENEMY2]++;
  mstate = 0;
  mcurrentpattern = (Graph *)mfirst;
  mindexpattern=0;
  maccel = (random() & 3) +2;
}

void Enemy2::  ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (mpower<=0) {
      Die();
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(250);
      }
    break;
  case MYSPACESHIP:
    Die();
    SetDirection(mdx+((mx-sp->mx)>>5),mdy+((my-sp->my)>>5));
    break;
  default:  
    break;
  }
}

void Enemy2::Move() {
  
  BouncingSprite::Move();
  
  if (mx<mwhich->mx-640) {
    mdx +=maccel;
  } else if (mx>mwhich->mx+640) {
    mdx -=maccel;
  }

  if (mdx<-80) mdx=-80;
  if (mdx>80) mdx=80;
  if ((mstate==0) && (mdx>0)) mstate =1;
  if ((mstate==2) && (mdx<0)) mstate =3;

  if ((!(random() & (mfireoften-1))) && (!fin) && ((mstate==0) || (mstate==2)))
    Fire();
}

void Enemy2::Draw() {
  if (mstate==1) {
    if (mindexpattern<6) {
      Next();
      mindexpattern++;
    } else {
      mstate =2;
    }
  }
  if (mstate==3) {
    if (mindexpattern<12) {
      Next();
      mindexpattern++;
    } else {
      mstate =0;
      mindexpattern=0;
      mcurrentpattern = (Graph *)mfirst;
    }
  }
  gl_putboxmask((-MCURRENT->mxCenter+mx)>>4,
		((-MCURRENT->myCenter+my)>>4)+(pageFlipping[!page]),
		MCURRENT->mwidth>>4,
		MCURRENT->mheight>>4,
		MCURRENT->mpattern);    
}


void Enemy2::Fire() {
  EnemyFire *sp;
  
  sp = new EnemyFire((ListSprite *)mlist,10,5);
  
  sp->SetLocation(mx+(mstate?16:-16),my);
  sp->SetDirection((mstate?0x80:-0x80),mdy>>2);
  sp->Copy(aenemy2fire);
  mlist->Add(sp);
}
  
void Enemy2::Die() {
  static Explosion *ex;
  static SpriteElem *ressort;
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aenemy2explosion);
  mlist->Add(ex);

  ressort = new Enemy2Dead((ListSprite *)mlist, (Enemy2 *)this);
  ressort -> SetDirection(mdx,mdy);
  mlist->Add(ressort);

  vie=0;

  if (snd) Snd_effect(9,CHFOES1);
}

Enemy2Dead::Enemy2Dead(ListSprite *list,Enemy2 *dead) : LinearSprite(list) {
  ((ListSprite *)mlist)->mnombre[ENEMY2DEAD]++;
  mtype=ENEMY2DEAD;
 
  mpoids = dead->get_mpoids()<<1;
  SetLocation(dead->mx,dead->my);
  SetDirection(dead->mdx >>2,0);
  Copy(aenemy2ressort);
}

void Enemy2Dead::Move() {
  mdy+=mpoids;
  Update();
  if (((mx<=-MCURRENT->mxCenter) && (mdx<0)) || ((mx>=WIDTH4+(MCURRENT->mwidth)+(MCURRENT->mxCenter)) && (mdx>0))  || (my>=HEIGHT4-SOL+MCURRENT->myCenter+MCURRENT->mheight))  {
    vie=0;
  }
}

/* ----------------------- Explosion ------------------- */


Explosion::Explosion(ListSprite *list, Sprite *sp):LinearSprite(list) {
  mtype=EXPLOSION;
  mx=sp->mx;
  my=sp->my;
  mdx=sp->mdx>>2;
  mdy=sp->mdy>>2;
  mtimer = 0;
  mwaitdeath=0;
  mhowmuchtime = 1;
}

void Explosion::Draw() {
  if (my<PLAFOND+MCURRENT->myCenter)
    my=PLAFOND+MCURRENT->mxCenter;
  if (my>HEIGHT4-SOL-MCURRENT->myCenter)
    my=HEIGHT4-SOL-MCURRENT->myCenter;
  SpriteElem::Draw();
  if (mcurrent==mfirst) {
    vie=0;
  }
  Prev();
  if (mwaitdeath)
    vie=1;
  if (vie) {
    if (!((mtimer++) & mhowmuchtime)) {
      if (!mwaitdeath) {
	Next();
      } else {
	vie=0;
      }
    }
  } else {
    vie=1;
    mwaitdeath = 1;
    mhowmuchtime = 3;
  }
}



/* ------------------ POWERUP -------------------*/

PowerUp::PowerUp(ListSprite *list) : LinearSprite(list) {
  Copy(apowerup);
  mtype=POWERUP;
  list->mnombre[POWERUP]++;
}
 
void PowerUp::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case WALL:
    mdx=-mdx;
    break;
  case MYFIRE:
    if (snd) Snd_effect(11,CHMISC);
    vie=0;
    break;
  case MYSPACESHIP:
    if (snd) Snd_effect(1,CHMISC);
    vie=0;
    break;
  default:  
    break;
  }
}

void PowerUp::Die() {
  if (my<=PLAFOND+MCURRENT->myCenter) {
    mdy = -mdy;
    my=PLAFOND+MCURRENT->myCenter;
  } else if (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
    mdy=-mdy;
    my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight;
  }
}



/* ------------------- ENEMY 4 --------------------- */


Enemy4::Enemy4(ListSprite *list,SpriteElem *which,short speed,short power,short number,short n,short x,short y) : TraceSprite(list, which,speed,1.35) {
  Sprite *sp;  
  
  menemy4prev=NULL;
  mx = x;
  my = y;
  mtype=ENEMY4;
  mpower=power;
  ((ListSprite *)mlist)->mnombre[ENEMY4]++;
  Copy(aenemy4);
  if (n<number) {
    sp = new Enemy4(list,this,speed,power,number,n+1,x,y);
    menemy4prev = (Enemy4 *)sp;
    list->Add((SpriteElem *)sp);
  }
}



void Enemy4::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(20);
    if (menemy4prev) 
      menemy4prev->set_mwhichone(mwhichone);
    if (mwhichone != mlist -> mfirst)
      ((Enemy4 *)mwhichone)->set_menemy4prev(menemy4prev);
    if (snd) Snd_effect(15,CHFOES1);
    Die();
    break;
  case MYFIRE:
    mpower -= ((MyFire *)sp)->mpower;
    if (snd) Snd_effect(15,CHFOES1);
    if (mpower<=0) {
      if (menemy4prev) 
	menemy4prev->set_mwhichone(mwhichone);
      if (mwhichone != mlist -> mfirst)
	((Enemy4 *)mwhichone)->set_menemy4prev(menemy4prev);
      ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(75);
      Die();
    }
    break;
  default:  
    break;
  }
} 

void Enemy4::Move() {
  TraceSprite::Move();
  if (my>=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight) {
    my=HEIGHT4-SOL+MCURRENT->myCenter-MCURRENT->mheight;
    Die();
  }
}


void Enemy4::Die() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aenemy4explosion);
  mlist->Add(ex);
  vie=0;
}

/* ------------------------ WALL ------------------------- */


Wall::Wall(ListSprite *list,short y,short width,short height,short dx,short dy): LinearSprite(list){
  GraphElem *graphelem;
  
  graphelem = new GraphElem(width,height);
  Add(graphelem);
  mtype=WALL;
  list->mnombre[WALL]++;
  //  printf("y : %i\n",y);
  SetLocation((640+(width>>1))<<4,(y+(height>>1))<<4);
  SetDirection(dx,dy);
}


void Wall::Draw() {

  //if ((((-MCURRENT->myCenter+my)>>4)<80) || (((-MCURRENT->myCenter+my+MCURRENT->mheight)>>4)>450))
  // printf("--> y : %i ; w : %i ; h : %i \n", ((-MCURRENT->myCenter+my)>>4),MCURRENT->mwidth>>4,MCURRENT->mheight>>4);
  //  printf(" number of walls : %i \n",((ListSprite *)mlist)->mnombre[WALL]);

  gl_fillbox(((-MCURRENT->mxCenter+mx)>>4),
      (((-MCURRENT->myCenter+my)>>4)+(pageFlipping[!page])),
      ((MCURRENT->mwidth>>4)),
      ((MCURRENT->mheight>>4)),
      4);
}

/* ---------------------- Enemy5 ----------------- */

Enemy5::Enemy5(ListSprite *list) : LinearSprite(list) {
  mtype=ENEMY5;
  Copy(aenemy5);
  ((ListSprite *)list)->mnombre[ENEMY5]++;
}

void Enemy5::Explose() {
  static Explosion *ex;
  
  ex = new Explosion((ListSprite *)mlist,(SpriteElem *)this);
  ex->Copy(aenemy5explosion);
  ex->SetDirection(mdx>>1,mdy>>1);
  mlist->Add(ex);
  vie=0;  
  if (snd) Snd_effect(4,CHFOES1);
}

void Enemy5::Die() {
  mdy=-mdy;
}

void Enemy5::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYSPACESHIP:
    ((MySpaceShip *)sp)->DecPower(20);
    Explose();
    break;
  case MYFIRE:
    ((MySpaceShip *)(((MyFire *)sp)->get_mfromwho()))->IncScore(50);
    Explose();
    break;
  default:  
    break;
  }
}

/* ----------------------- FEATURE --------------- */

Feature::Feature(ListSprite *list,short whichfeature): LinearSprite(list) {
  mtype = FEATURE;
  mwhichfeature = whichfeature ;
  Copy(afeature);
}

void Feature::ContactWith(Sprite *sp) {
  switch (sp->mtype) {
  case MYFIRE:
    if (snd) Snd_effect(11,CHMYSPACESHIP);
    vie=0;
    break;
  case MYSPACESHIP:
    if (snd) Snd_effect(1,CHMYSPACESHIP);
    vie=0;
    break;
  default:  
    break;
  }
}


/* ---------------------LAUNCH FIRE ------------------------*/

MyLaunchFire::MyLaunchFire(ListSprite *list,SpriteElem *whichone,int which):FollowingSprite(list,whichone,0,0) {
  mwhichlaunch = which;
  mtype = MYLAUNCHFIRE ;   
  Copy(amyspaceship);

  if (which & 1) {
    Next();
  }

  if (which & 2) {
    Next();
    Next();
  }

  if (which & 4) {
    Prev();
  }

  ((ListSprite *)list)->mnombre[MYLAUNCHFIRE]++;
}









