/* 
   SPACESHIPS'Sprites
   Interactions, animations, etc...
   are defined here !

   Xavier HOSXE
   */


#ifndef _SPACESHIPS_
#define _SPACESHIPS_

#include "MoreSprites.h"
#include "GraphElem.h"
#include "init.h"




extern short fin;

		
/* ---------------- My Space Ship ----------------*/

class MySpaceShip : public JoystickSprite {
protected:
  int mscore;
  short mmyfire;
  short mfirespeed;
  short mfirepower;
  short mcote;
  short moldpower[2];
  short moldscore[2];
  short mwhitetime;
  short mwin;
  short mtimer;
public:
  short mpower;
  MySpaceShip(ListSprite *list,short power,short speed,short firespeed,short firepower); 
  void SetPower();
  void set_mpower(short power);
  void IncPower(short i);
  void DecPower(short i);
  void DisplPower();
  void SetScore();
  void IncScore(short i);
  void DisplScore();
  void Move();
  void ContactWith(Sprite *sp);
  void Fire1();
  void Fire2();
  void Die();
  void LaunchMyFire();
  void Win();
  void Draw();
  void set_mmyfire(short m); 
  void set_mscore(int m) { mscore = m;}
};

class MyFire : public LinearSprite {
protected:
  short mpoids;
  MySpaceShip *mfromwho;
  short backfire;
public:
  MyFire(ListSprite *list,MySpaceShip *fromwho,short speed,short power);
  short mpower;
  MySpaceShip* get_mfromwho();
  void ContactWith(Sprite *sp);
  void Move();
  void Die();
  void Draw();
  void BackFire();
};

/* ------------------ Foes ----------------------*/

class Ball: public LinearSprite {
 public:
  Ball(ListSprite *sp);
  void ContactWith(Sprite *sp);
  void Die();
};


class Enemy2 : public BouncingSprite {
 protected:
  SpriteElem *mwhich;
  short mfireoften;
  short mstate;     
  // State :
  // 0 : going left
  // 1 : turning left to right;
  // 2 : going right
  // 3 : turinig right to left;
  Graph *mcurrentpattern;
  int mindexpattern;
  int maccel;
 public:
  short mpower;
  Enemy2(ListSprite *list,SpriteElem *,short firespeed,short power,short p);
  void ContactWith(Sprite *sp);
  void Move();
  void Fire();
  void Die();
  void Draw();
};

class Enemy2Dead : public LinearSprite {
 protected:
  short mpoids;
 public:
  Enemy2Dead(ListSprite *list,Enemy2 *dead);
  void Move();
};

class Enemy3 : public LinearSprite {
protected:
  short manim;
  short mfirespeed;
  short mfireoften;
public:
  short mpower;
  Enemy3(ListSprite *list,short power,short fireoften);
  void Move();
  void Die();
  void Draw();
  void ContactWith(Sprite *sp);
  void Fire();
  };

class Enemy3Fire : public TraceSprite {
 protected:
  char *mpos[8];
 public:
  Enemy3Fire(ListSprite *list,SpriteElem *mw,short speed);
  void ContactWith(Sprite *sp);
  void Die();
  void Draw();
  char* GoodPattern();
  void Move();
};


class EnemyFire : public LinearSprite {
public:
  short mpower;
  EnemyFire(ListSprite *list,short speed,short power);
  void ContactWith(Sprite *sp);
  void Die();
};

class Mine : public TraceSprite {
public:
  short mpower;
  Mine(ListSprite *list,SpriteElem *mw,short speed,short power);
  void ContactWith(Sprite *sp);
  void Die();
};

class Enemy1 : public SpringSprite {
protected:
  short mpower;
  short mfireoften;
  short mfirespeed;
public:
  Enemy1(ListSprite *list,short posx,short posy,short kx,short ky,short fireoften,short firespeed,short power);
  void Draw();
  void ContactWith(Sprite *sp);
  void Move();
  void Fire();
  void Die();
};


class Explosion : public LinearSprite {
protected:
  int mtimer;
  int mwaitdeath;
  int mhowmuchtime;
public:
  Explosion(ListSprite *list,Sprite *sp);
  virtual void Draw();
};

class PowerUp : public LinearSprite {
 public:
  PowerUp(ListSprite *list);
  void ContactWith(Sprite *sp);
  void Die();
};


class Enemy4 : public TraceSprite {
 protected:
  Enemy4 *menemy4prev;
  short mspeed;
  short mpower;
 public:
  Enemy4(ListSprite *list,SpriteElem *which,short speed,short number,short power, short n, short x,short y); 
  void ContactWith(Sprite *sp);
  void set_mspeed(short sp) {mspeed = sp;}
  void set_menemy4prev(Enemy4 *sp) {menemy4prev = sp;}
  void Move();
  void Die();
};



class Wall : public LinearSprite {
 public:
  Wall(ListSprite *list,short y, short width,short height,short dx,short dy);
  void Draw() ;
  void ContactWith() {}
  void Die() {mdy=-mdy;}
};



class Enemy5: public LinearSprite {
 public:
  Enemy5(ListSprite *sp);
  void ContactWith(Sprite *sp);
  void Die();
  void Explose();
};

class Feature : public LinearSprite {
 protected:
  short mwhichfeature;
 public:
  Feature(ListSprite *list,short mwhichfeature);
  void ContactWith(Sprite *sp);
  short get_mwhichfeature() { return mwhichfeature;}
};


class MyLaunchFire : public FollowingSprite {
protected:
  int mwhichlaunch;
public:
  MyLaunchFire(ListSprite *,SpriteElem *,int);
}; 


#endif

