/*

  Misc procedures
  SpaceBoom

  Xavier HOSXE
  */


#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include "Joystick.h"
#include "Sprite.h"
#include "GraphElem.h"
#include "init.h"
extern "C" {
#include "libmidi.h"
}


/* --------- ecrit ------------- */

void ecrit(short x,short y,char *st,short c) {
  gl_setfontcolors(0,c);
  gl_write(180+(x-1)*8,10+(y-1)*10,st);    
}


void clearScreen() {
  gl_fillbox(168,15,412,225,0);
}


/* ---- read and write options file ---- */
/* ---- Speed, autofire and level ------ */

short readOptionsFile() {
  FILE *fichier;
  
  if ((fichier=fopen("SpaceBoom.Options","r"))!=NULL) {		
    fread(&speedIndex,2,1,fichier);
    fread(&level,2,1,fichier);
    fread(&autofire_fs,2,1,fichier);
    fclose(fichier);
    return 0;
  } else {
    return 1;
  }
}

short writeOptionsFile() {
  FILE *fichier;
  if ((fichier=fopen("SpaceBoom.Options","w"))!=NULL) {
    fwrite(&speedIndex,2,1,fichier);
    fwrite(&level,2,1,fichier);
    fwrite(&autofire_fs,2,1,fichier);
    fclose(fichier);
    return 0;
  } else {
    return 1;
  }
}


/* --------- Restore All ------------ */

void restore_all(int sig) {
  exitJoystick();
  vga_setmode(TEXT);
  writeOptionsFile();  
  Midi_end();
  if (soundDev) Snd_restore();
  printf("\nI hope you enjoyed playing SpaceBoom 0.95.\n");
  printf("Tchaao !\n");
  printf("                 Xavier HOSXE (hosxe@dds.nl)\n\n");
  exit(sig);
}

/* ----------- Pause ------------- */


void Pause() {
  struct movement *js;   

  if (!enPause) {
    enPause =1;
    
    gl_putboxmask(215,
		  125+pageFlipping[page],
		  170,
		  53,
		  PauseG);
    
    js=readJoystick(0);
    while (!js->b1) js=readJoystick(0);
    fin=0;
    enPause=0;
  }
}

