/*
	
	highscore.cc
	Xavier HOSXE 

	Avril 1996

*/


#include <string.h>
#include <stdio.h>
#include <vga.h>
#include <vgagl.h>
#include <rawkey.h>
#include "soundIt.h"
#include "highscore.h"
#include "cadre.h"
#include "Joystick.h"
extern "C" {
#include "libmidi.h"
}
#define XMENU 180
#define YMENU 15

extern short snd;
extern short keyb;
extern GraphicsContext *gc_video,
                       *gc_background,
                       *gc_pres;

extern void clearScreen();

Halls bestScores;


Halls::Halls() {
  int i;
  for (i=0;i<10;i++) {
    number[i].score=0;
    number[i].name="              ";
  }
}

short Halls::CreateFile(void) {
  FILE *fichier;
  int xhscore;
  char xh[]="SpaceBoom";
  if ((fichier=fopen("SpaceBoom.HighScores","w"))!=NULL) {
    int i;
    for (i=0;i<10;i++) {
      xhscore = 10000 - i*1000;
      fwrite(&xhscore,4,1,fichier);
      fwrite(xh,1,15,fichier);
    }
    fclose(fichier);
    return 0;
  } else {
    return 1;
  }
}

short Halls::ReadFile(void) {
  FILE *fichier;
  if ((fichier=fopen("SpaceBoom.HighScores","r"))!=NULL) {
    int i;
    for (i=0;i<10;i++) {
      fread(&(number[i].score),4,1,fichier);
      fread(number[i].name,1,15,fichier);
      //printf(" Lecture %i : %s : %i \n",i,number[i].name,number[i].score);
    }
    fclose(fichier);
    return 0;
  } else {
    return 1;
  }
}

short Halls::WriteFile(void) {
  FILE *fichier;
  if ((fichier=fopen("SpaceBoom.HighScores","w"))!=NULL) {
    int i;
    for (i=0;i<10;i++) {
      fwrite(&(number[i].score),4,1,fichier);
      fwrite(&(number[i].name[0]),1,15,fichier);
    }
    fclose(fichier);
    return 0;
  } else {
    return 1;
  }
}

int Halls::Classement(int nouveauscore) {
  int i,classement=10;
  
  for (i=9;i>-1;i--) {
    if (nouveauscore>number[i].score) {
      classement=i;
    }
  }
  if (classement<10) {
    Insert(classement,nouveauscore);
  }
  return classement;
}

short Halls::Insert(int place,int nouveauscore) {
  int i;
  struct movement *js;
  
  for (i=9;i>place;i--) {
    Copy(&number[i],&number[i-1]);
  }
  number[place].score = nouveauscore;
  Display();
  gl_setfontcolors(0,132);
  //		clearScreen();
  gl_fillbox(XMENU+110,YMENU+216,200,8,0);
  gl_write(XMENU+130,YMENU+216,"Enter Your Name");	
  AskName(place);
  Display();
  gl_copyscreen(gc_video);
  WriteFile();
  js=readJoystick(0);
  while (!js->b1) js=readJoystick(0);
  clearScreen();
  return 0;
}

void Halls::Copy(high *dest,high *source) {
  dest->score = source->score;
  strcpy(dest->name,source->name);
}

void Halls::Display() {
  char title[]="HIGH SCORES";
  int i;
  char charscore[6];
  char charnumber[3];
  
  clearScreen();
  //  boxP(320-strlen(title)*4-10,138,strlen(title)*8+20,22,23);
  gl_setfontcolors(0,132);
  gl_write(XMENU+206-strlen(title)*4,YMENU+20,title);
  
  for (i=0;i<10;i++) {	
    gl_setfontcolors(0,81);
    sprintf(charnumber,"%i",i+1);
    gl_write(XMENU+60-strlen(charnumber)*8,YMENU+50+i*15,charnumber);
    gl_setfontcolors(0,220);
    gl_write(XMENU+140,YMENU+50+i*15,GetNameNumber(i));
    sprintf(charscore,"%i",GetScoreNumber(i));
    gl_setfontcolors(0,253);
    gl_write(XMENU+330,YMENU+50+i*15,"000000");
    gl_write(XMENU+378-strlen(charscore)*8,YMENU+50+i*15,charscore);
  }
  gl_setfontcolors(0,132);
  gl_write(XMENU+110,YMENU+216,"Press Fire To Go Back !");	
}


// ==== Clavier ======

int valable(int key)
{
  int val=0,i=0;
  int key_v[]={32,46,47,42,43,45,95,0};
  
  if ((key>=97) && (key<=122))
    return 1;
  if ((key>=65) && (key<=90))
    return 1;
  if ((key>=48) && (key<=57))
    return 1;

  while ((val==0) && (key_v[i]!=0))
    {
      if (key_v[i]==key)
        val=1;
      i++;
    }
  return val;
}



void Halls::AskName(int place) {
  char reponse[15];
  char char_aff[]=" ";
  int key=0;
  int aff_x=0;
  int x=XMENU+140;
  int y=YMENU+50+place*15;

  if (keyb) 
	rawmode_exit();

  if (snd) Snd_effect(13,0);

  gl_setfontcolors(0,81);
	
  boxM(XMENU+140-3,YMENU+50+place*15-3,128,14,0);

  gl_copyscreen(gc_video);
  gl_setcontext(gc_video);
  gl_setdisplaystart(0,0);

  while ((key!=10) && (aff_x<15) && (key!=27))
    {
      key=vga_getkey();
      if (((key==126) || (key==127)) && (aff_x>0))
        {
          aff_x --;
	  reponse[aff_x]=0;
          gl_fillbox(x+aff_x*8,y,8,8,0);
	  if (snd) Snd_effect(8,4);
        }
      if (valable(key))
        {
          char_aff[0]=key;
          gl_write(x+aff_x*8,y,char_aff);
          reponse[aff_x]=char_aff[0];
          aff_x ++;
	  if (snd) Snd_effect(8,4);
	}
	
    }

  if (!aff_x)
    strcpy(reponse,"Nobody");
  reponse[aff_x]=0;
  strcpy(number[place].name,reponse);  
  //printf(" Reponse : %s \n",reponse);

  if (keyb)
 	rawmode_init();
  gl_setcontext(gc_pres);
}



