/*

  init.cc

  contains informations that are often changed

  Xavier HOSXE
  June 1996

  */


#include <soundIt.h>
#include "gif.h"
#include "ListSprite.h"

#define MCURRENT ((GraphElem *) mcurrent)

/* --------- VARIABLES GLOBALE ------------- */


Sample sons[18];
char *TopBar;
char *BottomBar;
char *PauseG;
char **buildings;
char **spaceGraphs;
char **bgLastGraphs;
unsigned char *vbuf;
short snd=1,joystick=1,player=1,level=1,often=4;
short fin=0,autofire,autofire_fs = 2;
int highScore = 0;
int actualScore=0;
int actualPower;
short soundDev; 
ListSprite *list;
short enPause=0;
short enJeu=0;
short Town=0, Towers=0, Space=0, Final=0;
Palette *defaultPalette;
Palette *defaultPaletteGif;
short myfire;
short speed=28;
short speedIndex = 3;

Animation *amyspaceship,*amyspaceshipexplosion,
          *amyfire,*amyfireexplosion,
	  *abackfire,
          *aenemy1creation,*aenemy1,*aenemy1explosion,*aenemy1fire,
	  *amine,*amineexplosion,
	  *aenemy2,*aenemy2ressort,*aenemy2explosion,*aenemy2fire,
	  *aball,
	  *atitre,
	  *aenemy3,*aenemy3fire,*aenemy3legs,*aenemy3explosion,*aenemy3fireexplosion,
	  *apowerup,
	  *aenemy4,*aenemy4explosion,
	  *aenemy5,*aenemy5explosion,
	  *afeature,
	  *agameover,
	  *alastspaceship,*alastspaceshipattack,*alastspaceshipexplosion,*alastspaceshipattack2,
          *alastspaceshiptir1,*alastspaceshiptir2,
          *alargueur, *alargueurexplosion, *alargueurfire, *alargueurfireexplosion,
          *apause,
          *aasteroid,
          *ameteor1,*ameteor1explosion,
          *ameteor2,*ameteor2explosion,
          *aplane1,*aplane2,*aplane3,*aplane4,*aplane5,*aplaneexplosion,
          *aftower,*aftowerexplosion,*aftowerfire,
          *abigturning,*abigturningexplosion,*abigturningfire;





/* --------------- init Sounds -------------------*/


short initSounds() {
  Snd_loadRawSample("snd/MySpaceShipFire.raw",&sons[0]);
  Snd_loadRawSample("snd/PowerUp.raw",&sons[1]);
  Snd_loadRawSample("snd/Enemy1Creation.raw",&sons[2]);
  Snd_loadRawSample("snd/Enemy1Explosion.raw",&sons[3]);
  Snd_loadRawSample("snd/Enemy5Explosion.raw",&sons[4]);
  Snd_loadRawSample("snd/MySpaceShipTouched.raw",&sons[5]);
  Snd_loadRawSample("snd/ferraille.raw",&sons[6]);
  Snd_loadRawSample("snd/Welcome.raw",&sons[7]);
  Snd_loadRawSample("snd/NewChoice.raw",&sons[8]);
  Snd_loadRawSample("snd/MineExplosion.raw",&sons[9]);
  Snd_loadRawSample("snd/largueur.explosion.raw",&sons[10]);
  Snd_loadRawSample("snd/No.raw",&sons[11]);
  Snd_loadRawSample("snd/Water.raw",&sons[12]);
  Snd_loadRawSample("snd/Super.raw",&sons[13]);
  Snd_loadRawSample("snd/MySpaceShip.explosion.raw",&sons[14]);
  Snd_loadRawSample("snd/Enemy4Explosion.raw",&sons[15]);
  Snd_loadRawSample("snd/VaisseauFinalTir.raw",&sons[16]);
  Snd_loadRawSample("snd/VaisseauFinalDes.raw",&sons[17]);
  if (Snd_init(5,sons,8000,16,"/dev/dsp")) {
    return 0;
  } else {
    return 1;
  }
}


/* ------------------- Init graphics ------------------- */

void initAnimations() {
  fprintf(stderr,"Reading Sprites");

  amyspaceship = new Animation("graphs/my.space.ship.spr");
  amyspaceshipexplosion= new Animation("graphs/my.space.ship.explosion.spr");
  amyfire = new Animation("graphs/myFire.spr");
  amyfire->SetSize(16,4);
  amyfireexplosion = new Animation("graphs/myFireExplosion.spr");
  aenemy1 = new Animation("graphs/tie.spr");
  aenemy1explosion  = new Animation("graphs/tie.explosion.spr");
  aenemy1creation  = new Animation("graphs/tie.creation.spr");
  aenemy1fire = new Animation("graphs/enemy1Fire.spr");
  amine = new Animation("graphs/mine.spr");
  amineexplosion = new Animation("graphs/mineExplosion.spr");
  aball = new Animation("graphs/ball.spr");
  aenemy2 = new Animation("graphs/enemy2.spr");
  aenemy2ressort = new Animation("graphs/enemy2ressort.spr");
  aenemy2explosion = new Animation("graphs/enemy2explosion.spr");
  aenemy2fire = new Animation("graphs/Enemy2Fire.spr");
  atitre = new Animation("graphs/titre.spr");
  aenemy3 = new Animation("graphs/Enemy3.spr");
  aenemy3explosion = new Animation("graphs/Enemy3Explosion.spr");
  aenemy3fireexplosion = new Animation("graphs/Enemy3FireExplosion.spr");
  aenemy3fire = new Animation("graphs/Enemy3Fire.spr");
  apowerup = new Animation("graphs/PowerUp.spr");
  aenemy4 = new Animation("graphs/Enemy4.spr");
  aenemy4explosion = new Animation("graphs/Enemy4Explosion.spr");
  aplane1 = new Animation("graphs/plane1.spr");
  aplane2 = new Animation("graphs/plane2.spr");
  aplane3 = new Animation("graphs/plane3.spr");
  aplane4 = new Animation("graphs/plane4.spr");
  aplane5 = new Animation("graphs/plane5.spr");
  aplaneexplosion = new Animation("graphs/planeexplosion.spr");
  abackfire = new Animation("graphs/BackFire.spr");
  abackfire->SetSize(16,4);
  afeature = new Animation("graphs/Feature.spr");
  agameover = new Animation("graphs/GameOver.spr");
  alastspaceship = new Animation("graphs/final.spr");
  alastspaceshiptir1 = new Animation("graphs/vaisseauFinTir1.spr");
  alastspaceshiptir2 = new Animation("graphs/vaisseauFinTir2.spr");
  alastspaceshipattack = new Animation("graphs/final.attack.spr");
  alastspaceshipattack2 = new Animation("graphs/final.attack2.spr");
  alastspaceshipexplosion = new Animation("graphs/final.explosion.spr");
  alargueur = new Animation("graphs/largueur.spr");
  alargueurexplosion = new Animation("graphs/largueur.explosion.spr");
  alargueurfire = new Animation ("graphs/largueur.fire.spr");
  alargueurfireexplosion = new Animation("graphs/largueur.fire.explode.spr");
  aasteroid = new Animation("graphs/aster.spr");
  ameteor1 = new Animation("graphs/meteor1.spr");
  ameteor1explosion = new Animation("graphs/meteor1.explosion.spr");
  ameteor2 = new Animation("graphs/meteor2.spr");
  ameteor2explosion = new Animation("graphs/meteor2.explosion.spr");
  abigturningfire = new Animation("graphs/big.turning.fire.spr");
  abigturning = new Animation("graphs/big.turning.spr");
  abigturningexplosion = new Animation("graphs/big.turning.explosion.spr");
  aftower = new Animation("graphs/flying.tower.spr");
  aftowerexplosion = new Animation("graphs/flying.tower.explosion.spr");
  aftowerfire = new Animation("graphs/ftower.fire.spr");
  //  apause = new Animation("graphs/pause.spr");



  //  fprintf(" apause : %i %i\n",apause->MCURRENT->mwidth,apause->MCURRENT->mheight);

  fprintf(stderr,"\n");
}

/* ------------------ Init misc graph --------------- */

extern void restore_all(int);


void initGraphs() {
  FILE *fichier;
  int i,r,g,b;

  fichier = popen("gzip -c -d 'graphs/topbar.raw'","rb");
  TopBar = new char[50560];
  fread(TopBar,1,50560,fichier);
  pclose(fichier);

  fichier = popen("gzip -c -d graphs/bottom.raw","rb");
  BottomBar = new char[25600];
  fread(BottomBar,1,25600,fichier);
  pclose(fichier);

  fichier = popen("gzip -c -d graphs/pause.raw","rb");
  PauseG = new char[9010];
  fread(PauseG,1,9010,fichier);
  pclose(fichier);


  buildings = new (char *)[10];

  fichier = popen("gzip -c -d graphs/buildings.raw","rb");
  for (i=0;i<8;i++) {
    buildings[i] = new char[4096];
    fread(buildings[i],1,4096,fichier);
  }
  pclose(fichier);

  spaceGraphs = new (char *)[10];

  fichier = popen("gzip -c -d graphs/space1.raw","rb");
  for (i=0;i<8;i++) {
    spaceGraphs[i] = new char[4096];
    fread(spaceGraphs[i],1,4096,fichier);
  }
  pclose(fichier);


  bgLastGraphs = new (char *)[9];

  fichier = popen("gzip -c -d graphs/bglast1.raw","rb");
  for (i=0;i<9;i++) {
    bgLastGraphs[i] = new char[4096];
    fread(bgLastGraphs[i],1,4096,fichier);
  }
  pclose(fichier);

  /* -- Initialise Palette -- */
  defaultPalette = new Palette;

  fichier = fopen("graphs/Palette.spaceboom","r");
  for (i=0;i<255;i++) {
    fread(&r,4,1,fichier);
    fread(&g,4,1,fichier);
    fread(&b,4,1,fichier);
    gl_setpalettecolor(i,r,g,b);
  }

  gl_getpalette(defaultPalette);
}



