/*

  init.h

  included by SpaceShips.h
  contains informations that are often changed

  Xavier HOSXE
  June 1996

  */



#ifndef __INIT__
#define __INIT__

#include "soundIt.h"
#include "Animation.h"
#include "ListSprite.h"


#define WAIT -1
#define FIN -2
#define CHANGE_BUILDING -3
#define TEMPS -4

#define MYSPACESHIP 1
#define BALL 2
#define MINE 3
#define MYFIRE 4
#define ENEMY1 5
#define EXPLOSION 6
#define ENEMY1FIRE 7
#define POWER 8
#define ENEMY2 9
#define ENEMY2FIRE 10
#define ENEMY1CREATION 11
#define ENEMY2DEAD 12
#define ENEMY3 13
#define ENEMY3FIRE 14
#define POWERUP 16
#define ENEMY4 17
#define WALL 18
#define ENEMY5 19
#define FEATURE 20
#define MYBACKFIRE 21
#define BACKFIRE 22
#define MYTRIPLEFIRE 23
#define LASTSPACESHIP 24
#define LASTSPACESHIPFIRE1 25
#define LASTSPACESHIPFIRE2 26
#define LARGUEUR 27
#define LARGUEURFIRE 28
#define ASTEROID 29
#define METEOR 30
#define PLANE 31
#define FTOWER 32
#define FTOWERFIRE 33
#define BIGTURNING 34
#define MYTRIPLEFIRE1 35
#define MYTRIPLEFIRE2 36
#define MYLAUNCHFIRE 37

#define CHMYFIRE 0
#define CHMYSPACESHIP 1
#define CHFOES1 2
#define CHFOES2 3
#define CHMISC 4


//  For the final space ship
#define CREATION 1
#define DESINTEGRATION 2
#define ATTACKBEGIN 3
#define ATTACKEND 4
#define NORMAL 5
#define NOWHERE 6
#define CREATIONROBOT1 7
#define CREATIONROBOT2 8
#define FINALEXPLOSION 9
#define SHOOTING 10

extern Animation *amyspaceship,*amyspaceshipexplosion,
                 *amyfire,*amyfireexplosion,
                 *abackfire,
                 *aenemy1creation,*aenemy1,*aenemy1explosion,*aenemy1fire,
		 *amine,*amineexplosion,
                 *aenemy2,*aenemy2ressort,*aenemy2explosion,*aenemy2fire,
                 *aball,
		 *atitre,
		 *aenemy3,*aenemy3fire,*aenemy3legs,*aenemy3explosion,*aenemy3fireexplosion,
                 *apowerup,
                 *aenemy4,*aenemy4explosion,
                 *aenemy5,*aenemy5explosion,
                 *afeature,
                 *agameover,
                 *alastspaceship,*alastspaceshipattack,*alastspaceshipexplosion,*alastspaceshipattack2,
                 *alastspaceshiptir1,*alastspaceshiptir2,
                 *alargueur, *alargueurexplosion, *alargueurfire, *alargueurfireexplosion,
                 *apause,
                 *aasteroid,
                 *ameteor1,*ameteor1explosion,
                 *ameteor2,*ameteor2explosion,
                 *aplane1,*aplane2,*aplane3,*aplane4,*aplane5,*aplaneexplosion,
                 *aftower,*aftowerexplosion,*aftowerfire,
                 *abigturning,*abigturningexplosion,*abigturningfire;


extern Sample sons[18];
extern void initAnimations();
extern void initGraphs();
extern short initSounds();
extern void restore_all(int);
extern char *TopBar;
extern char *BottomBar;
extern char *PauseG;
extern char **buildings;
extern char **spaceGraphs;
extern char **bgLastGraphs;
extern unsigned char *vbuf;
extern short snd,joystick,player,level,often;
extern short fin,autofire,autofire_fs;
extern int highScore;
extern int actualScore;
extern int actualPower;
extern short soundDev; 
extern ListSprite *list;
extern short enPause;
extern short enJeu;
extern short Town, Towers, Space, Final;
extern Palette *defaultPalette;
extern Palette *defaultPaletteGif;
extern short myfire;
extern short speed;
extern short speedIndex;

#endif

