/* =============================
   
               MAIN
             SpaceBoom
   
                    Xavier HOSXE
		    hosxe@dds.nl
   ============================= */

#include <stdio.h>
#include <stdlib.h>
#include <vga.h>
#include <vgagl.h>
#include <vgakeyboard.h>
#include <signal.h>
#include <unistd.h>
#include "cadre.h"
#include "ListSprite.h"
#include "Sprite.h"
#include "tableau.h"
#include "SpaceShips.h"
#include "NewSpaceShips.h"
#include "LastSpaceShip.h"
#include "scroll.h"
#include "ListChoice.h"
#include "btypes.h"
#include "gif.h"
#include "sqrt.h"
#include "Joystick.h"
#include "highscore.h"
#include "divers.h"
extern "C" {
#include "libmidi.h"
}



#define VSCREEN 1024
#define EV (tableau[ev++])



/* ----- The playing procedure ---- */

int PlaySpaceBoom() {
  short gagne =0;
  int i,musicMort = 0;
  int ev=0;
  int time=-10,time1=0;
  SpriteElem *sprite;
  short waitFor=0;
  short posScroll=0;
  char charscore[6];
  struct movement *js;


  /* --- Debut Jeu -- */
  enJeu = 1;

  /* --------------- MUSIQUE DU JEU ------------------ */
  gl_setcontext(gc_video);
  gl_clearscreen(0);	


  /* -- Clear Background -- */
  gl_setcontext(gc_background);
  gl_clearscreen(0);
  for (i=0;i<1000;i++) {
    gl_setpixel((random() % 704),random() & 511,(random() & 15)+16);
  }  
  gl_setcontext(gc_video);
  page=1;
  gl_setscreenoffset(0);

  
  /* --- palette INIT --- */
  gl_setpalette(defaultPalette);
  
  

  /* ------------------ */
  /* -- Presentation -- */
  
  gl_putbox(0,0,640,79,TopBar);
  gl_putbox(0,440,640,40,BottomBar);
  
  gl_setfontcolors(22,30);    
  gl_write(151,40,"000000");
  gl_write(151+260,40,"000000");
  gl_setfontcolors(22,10); 
  gl_write(151+130,40,"000000");
  sprintf(charscore,"%i",highScore);
  gl_setfontcolors(22,10); 
  gl_write(151+130+8*(6-strlen(charscore)),40,charscore);
  
  /* --- my space ship INIT --- */
  list = new ListSprite;
  
  sprite = new MySpaceShip(list,10,10,10,10);
  // printf("> .84\n");  
  sprite->SetLocation(16<<4,200<<4);
  // printf("> .85\n");  
  sprite->Copy(amyspaceship);
  // printf("> .86\n");  
  ((MySpaceShip *)sprite)->SetPower();
  // printf("> .87\n");  
  list->Add(sprite);
  ((MySpaceShip *)sprite)->set_mscore(actualScore);
  ((MySpaceShip *)sprite)->set_mmyfire(myfire);
  ((MySpaceShip *)sprite)->set_mpower(actualPower);
  
  // printf("> 1\n");  
  
  
    gl_copybox(0,0,640,480,0,512);	


    /* -- init many things -- */
    time1=-10;
    time=0;

    fin = 0;
    ev  = 0;
    musicMort=0;

    switch (level) {
    case 4:
      often=1;
      break;
    case 2:
      often=2;
      break;
    case 1:
      often=4;
      break;
    }


    /* ======== BOUCLE JEU ========== */

    while (fin!=3) {
      
      page=!page;
      
      gl_setdisplaystart(0,pageFlipping[page]); 
      vga_waitretrace();
     
      // printf("Scrolling \n");
      
      if (!fin) {
	scroll(posScroll=(int)(((((SpriteElem *)(list->mfirst))->my>>4)-80)*.432));
      } else {
	if (fin==1) {
	  gl_setpalettecolor(0,0,0,0);
	  if (gagne == 1) {
	    gl_setdisplaystart(0,0);
	    gl_setpalettecolor(0,0,0,0);
	    list->Vide();
	    enJeu = 0;
	    return 1;
	  }
	  sprite = new SpriteElem(list);
	  sprite->SetLocation(292<<4,150<<4);
	  sprite->Copy(agameover);
	  Midi_play("midi/spaceboom1.mid");
	  musicMort=1;
	  list->Add(sprite);
	  fin=2;
	  time=0;
	} else if (fin==2) {
	  js = readJoystick(0);
	  if ((js->b1) && (time>40)) {
		js = readJoystick(0);
          	while (js->b1) {
		  js = readJoystick(0);
		}
 		fin=3;
	  }
	}
	
	scroll(posScroll);
      }
      
      //printf("Move \n");
      list->MoveSprites();
      //printf("Interaction \n");
      list->Interaction();
      //printf("Drawing \n");
      
      gl_setclippingwindow(0,80+(pageFlipping[!page]),639,439+(pageFlipping[!page])); 
      list->DrawSprites();
      gl_disableclipping();
          
      
      time++;
      
      if ((!list->mnombre[waitFor]) && (!fin)) {
	waitFor=0;
	if (time>time1) {
	  switch ((int)EV) {
	  case ENEMY1:
	    sprite = new Enemy1(list,tableau[ev]<<4,tableau[ev+1]<<4,tableau[ev+2],tableau[ev+3],(int)tableau[ev+4]*often,(int)tableau[ev+5]+level,(int)tableau[ev+6]);
	    sprite->SetLocation(tableau[ev+7]<<4,tableau[ev+8]<<4);
	    sprite->SetDirection(tableau[ev+9]<<4,tableau[ev+10]<<4);
	    list->Add(sprite);
	    ev+=11;
	    time1 =(int)EV;
	    break;
	  case MINE:
	    sprite = new Mine(list,(SpriteElem *)list->mfirst,tableau[ev],(int)tableau[ev+1]) ;
	    sprite->SetLocation(tableau[ev+2]<<4,tableau[ev+3]<<4);
	    list->Add(sprite);
	    ev+=4;
	    time1 =(int)EV;
	    break;
	  case ENEMY2:
	    sprite = new Enemy2(list,(SpriteElem *)list->mfirst,(int)tableau[ev]*often,(int)tableau[ev+1],tableau[ev+2]);
	    sprite->SetLocation(tableau[ev+3]<<4,tableau[ev+4]<<4);
	    sprite->SetDirection(tableau[ev+5]<<4,tableau[ev+6]<<4);
	    list->Add(sprite);
	    ev+=7;
	    time1 =(int)EV;
	    break;
	  case BALL:
	      sprite = new Ball(list);
	      if (tableau[ev]>0) {
		sprite->SetLocation(tableau[ev]<<4,tableau[ev+1]<<4);
		sprite->SetDirection(tableau[ev+2]<<4,tableau[ev+3]<<4);
		ev+=4;
	      } else {
		// 10560 = 660 * 16
		sprite->SetLocation(10560,((random() & 255) + 120) <<4);
		sprite->SetDirection(((random() & 3) -6)<<4 ,((random() & 7) -3)<<4);
		ev+=1;
	      }
	    if ((level>1) || ((level==1) && (random() & 1))) {
	      sprite->Copy(aball);
	      list->Add(sprite);
	    } else {
	      delete sprite;
	    }
	    time1 =(int)EV;
	    break;
	  case ENEMY3:
	    sprite = new Enemy3(list,(int)tableau[ev],(int)tableau[ev+1]*often);
	    sprite->SetLocation(660<<4,417<<4);
	    sprite->SetDirection(tableau[ev+2]<<4,tableau[ev+3]<<4);
	    list->Add(sprite);
	    ev+=4;
	    time1 =(int)EV;
	    break;
	  case ENEMY4:
	    sprite = new Enemy4(list,(SpriteElem *)list->mfirst,tableau[ev],tableau[ev+1],tableau[ev+2],0,tableau[ev+3]<<4,tableau[ev+4]<<4);
	    sprite->SetDirection(tableau[ev+5]<<4,tableau[ev+6]<<4);
	    list->Add(sprite);
	    ev+=7;
	    time1 =(int)EV;
	    break;
	  case FTOWER:
	    sprite = new Ftower(list,(int)tableau[ev]);
	    ev+=1;
	    list->Add(sprite);
	    time1 =(int)EV;
	    break;
	  case PLANE:
	    switch (tableau[ev]) {
	    case 1:
	      sprite = new Plane1(list);
	      list->Add(sprite);
	      break;
	    case 2:
	      sprite = new Plane2(list);
	      list->Add(sprite);
	      break;
	    case 3:
	      sprite = new Plane3(list);
	      list->Add(sprite);	      
	      break;
	    case 4:
	      sprite = new Plane4(list);
	      list->Add(sprite);
	      break;
	    case 5:
	      sprite = new Plane5(list);
	      list->Add(sprite);
	      break;
	    }
	    if (tableau[ev+1]>=0) {
	      sprite->SetLocation(tableau[ev+1]<<4,tableau[ev+2]<<4);
	      sprite->SetDirection(tableau[ev+3]<<4,tableau[ev+4]<<4);
	      ev+=5;
	    } else {
	      sprite->SetLocation(660<<4,((random() & 255) +120)<<4);
	      sprite->SetDirection((-(random() & 3)-4)<<4,((random() & 3)-1)<<4);
	      ev+=2;
	    }

	    time1 =(int)EV;
	    break;
	  case ASTEROID:
	    sprite = new Asteroid(list,tableau[ev]);
	    sprite->SetLocation(tableau[ev+1]<<4,tableau[ev+2]<<4);
	    sprite->SetDirection(tableau[ev+3]<<4,tableau[ev+4]<<4);
	    list->Add(sprite);
	    ev+=5;
	    time1 =(int)EV;
	    break;
	  case METEOR:
	    sprite = new Meteor(list,2);
	    sprite->SetLocation(tableau[ev]<<4,tableau[ev+1]<<4);
	    sprite->SetDirection(tableau[ev+2]<<4,tableau[ev+3]<<4);
	    list->Add(sprite);
	    ev+=4;
	    time1 =(int)EV;
	    break;
	  case LARGUEUR:
	    sprite = new Largueur(list,tableau[ev],tableau[ev+1]*often);
	    sprite->SetLocation(656<<4,85<<4);
	    sprite->SetDirection(tableau[ev+2],0);
	    list->Add(sprite);
	    ev+=3;
	    time1 =(int)EV;
	    break;
	  case BIGTURNING:
	    sprite = new Bigturning(list,tableau[ev],tableau[ev+1]*often,tableau[ev+2]);
	    sprite->SetLocation(672<<4,tableau[ev+3]<<4);
	    sprite->SetDirection(tableau[ev+4],0);
	    list->Add(sprite);
	    ev+=5;
	    time1 =(int)EV;
	    break;
	  case LASTSPACESHIP:
	    sprite = new LastSpaceShip(list,tableau[ev]*often,tableau[ev+1]+20*level);
	    sprite->SetLocation(tableau[ev+2]<<4,tableau[ev+3]<<4);
	    list->Add(sprite);
	    ev+=4;
	    time1 =(int)EV;
	    break;
	  case POWERUP:
	    sprite = new PowerUp(list);
	    sprite->SetLocation(tableau[ev]<<4,tableau[ev+1]<<4);
	    sprite->SetDirection(tableau[ev+2]<<4,tableau[ev+3]<<4);
	    list->Add(sprite);
	    ev+=4;
	    time1 =(int)EV;
	    break;
	  case WALL:
	    sprite = new Wall(list,tableau[ev],tableau[ev+1],tableau[ev+2],tableau[ev+3]<<4,tableau[ev+4]<<4);
	    list->Add(sprite);
	    ev+=5;
	    time1 =(int)EV;
	    break;
	  case FEATURE:
	    sprite = new Feature(list,tableau[ev]);
	    sprite->SetLocation(648<<4,tableau[ev+1]<<4);
	    sprite->SetDirection(tableau[ev+2]<<4,0);
	    list->Add(sprite);
	    ev+=3;
	    time1 =(int)EV;
	    break;
	  case WAIT:
	    if ((waitFor=(short)EV)==TEMPS) {
	      waitFor=0;
	      time1=(short)EV;
	    }
	    break;
	  case FIN:
	    gagne = 1;
	    ((MySpaceShip *)((ListSprite *)list)->mfirst)->Win();
 	    break;
	  default:
	    break;
	  }
	  time=0;
	}
      }
    }
    gl_setdisplaystart(0,0);
    gl_setpalettecolor(0,0,0,0);
    list->Vide();
    enJeu = 0;
    return 0;
}



/* ==============================================
      
                 MAIN PROGRAM

   ==============================================*/



main() 
{
  int i,j;
  int Continue;
  short choix1,choix2,choix3;
  Gif *presGif;
  int re,gr,bl;
  char charscore[6];
  struct movement *js;
  char charpower[15];
  ListChoice menu1("MAIN MENU");
  ListChoice menu2("OPTIONS");
  ListChoice menu3("INFORMATIONS");
  ListChoice menu4("MISSIONS");


  /* ========== MENU =========== */
     
  static char SON_ON[]    =  "SOUND :  ON";
  static char SON_OFF[]   =  "SOUND : OFF";
  static char MIDI_ON[]   =  "MIDI :  ON";
  static char MIDI_OFF[]  =  "MIDI : OFF";

  /*  static char PLAYER1[]   =  "Player : 1";
   *   static char PLAYER2[]   =  "Player : 2";
   */

  static char SPEED[6][20] ;
  static short arraySpeed[] = { 12,18,23,28,35,45 };
  static short arrayAutofire[] = { 9,6,5,4,3,2 };

  static char LEVEL1[]    =  "Level  :   Easy";
  static char LEVEL2[]    =  "Level  : Medium";
  static char LEVEL3[]    =  "Level  :   Hard";
  static char AUTOFIRE1[] =  "AutoFire : Slow";
  static char AUTOFIRE2[] =  "AutoFire : Fast";

  static char MISSION1[]  =  "The Town";
  static char MISSION1C[] =  "Completed";
  static char MISSION2[]   =  "The space";
  static char MISSION2C[]   =  "Completed";
  static char MISSION3[]  =  "The Towers";
  static char MISSION3C[] =  "Completed";
  static char MISSION4[]   =  "The final one";

  static char MAINMENU1[] = "PLAY NOW";
  static char MAINMENU2[] = "HIGH SCORES";
  static char MAINMENU3[] = "OPTIONS";
  static char MAINMENU4[] = "INFOS";
  static char MAINMENU5[] = "QUIT";

  static char ABOUT1[] = "About Xavier HOSXE";
  static char ABOUT2[] = "About SpaceBoom";
  static char ABOUT3[] = "Acknowledgement";
  static char ABOUT4[] = "How to play";
  static char ABOUT5[] = "RETURN PREVIOUS MENU";
    
  strcpy(SPEED[0],"Speed : Very Slow");
  strcpy(SPEED[1],"  Speed : Slow   ");
  strcpy(SPEED[2]," Speed : Medium -");
  strcpy(SPEED[3]," Speed : Medium +");
  strcpy(SPEED[4],"  Speed : Fast   ");
  strcpy(SPEED[5],"Speed : Very Fast");

  /*--- INIT ----*/

  if (bestScores.ReadFile()) {
    printf("No Best Scores File !!\n");
    printf("Creating Best Scores file...\n");
    bestScores.CreateFile();
    if (bestScores.ReadFile()) {
      printf("No Best Scores File !! AGAIN ???? \n");
      printf("Please, Check the access rights of this directory \n");
      printf("And start again Spaceboom\n");
      exit(1);
    }
  } 
  
  /* highScore contains the HIGH SCORE (?) */
  highScore = bestScores.GetScoreNumber(0);
  
  if (readOptionsFile()) {
    printf("No options file !!\n");
    printf("It will be created when you exit !\n\n");
  }
  
  /* -- initialize an array of square root -- */
  sqrtSoftInit();

  joystick=initJoystick(0);


  /* -- initialise Animation -- */
  initAnimations(); // defined in SpaceShip.cc 


  signal(SIGINT,restore_all);
  signal(SIGQUIT,restore_all);
  signal(SIGKILL,restore_all);

  gc_video = new GraphicsContext;
  gc_background = new GraphicsContext;
  gc_pres = new GraphicsContext;

  vga_init();
  vga_setmode(MODE);
  gl_setcontextvga(MODE);
  gl_getcontext(gc_video);

  initGraphs();

  // ---------------------------------------------------  
  // Uncomment the second part and commant the first one 
  // if you have problem with your soundcard.  
  snd=soundDev=initSounds(); 
  //  snd=soundDev=0; 

  Midi_init(MIDI_CARD);

  // MIDI_CARD = 1 ; GUS ('-g')
  // MIDI_CARD = 2 ; Sound Blaster (aouch !) ('-f')
  // MIDI_CARD = 3 ; External midi sound module ('-e')
  // MIDI_CARD = 0 ; No music !
  // This only modify the options when playmidi 
  // is called:
  // ---------------------------------------------------


  if (!joystick) initKeyboard();

   /* ---- Premiere Page de presentation ---- */
  presGif = new Gif; 
  defaultPaletteGif = new Palette;

  presGif->Load("graphs/SpaceBoom1.gif");
  for (i=0;i<256;i++)  {
    gl_setpalettecolor(i,0,0,0);
  } 

  gl_putbox(0,0,640,480,presGif->getPtr());
  if (snd) Snd_effect(7,CHMISC);
  for (j=0;j<64;j++) {
    for (i=0;i<256;i++)  {
      re = (presGif->Red[i]>>2)+2 ;
      gr = (presGif->Green[i]>>2)+2 ;
      bl = (presGif->Blue[i]>>2)+2 ;
      re = ((re > j)? j:re);
      gr = ((gr > j)? j:gr);
      bl = ((bl > j)? j:bl);
      gl_setpalettecolor(i,re,gr,bl);
    }
    usleep(15000);
  }
  /* ----- Premiere page affichee ----- */


  js=readJoystick(0);
  while (!js->b1) js=readJoystick(0);

  for (j=63;j>=0;j--) {
    for (i=0;i<256;i++)  {
      re = (presGif->Red[i]>>2)+2 ;
      gr = (presGif->Green[i]>>2)+2 ;
      bl = (presGif->Blue[i]>>2)+2 ;
      re = ((re > j)? j:re);
      gr = ((gr > j)? j:gr);
      bl = ((bl > j)? j:bl);
      gl_setpalettecolor(i,re,gr,bl);
    }
    usleep(15000);
  }

  delete presGif ;

  /* -- preparation menu page -- */
  presGif = new Gif; 
  presGif->Load("graphs/SpaceBoom2.gif");
  for (i=0;i<256;i++)  {
    gl_setpalettecolor(i,0,0,0);
  } 
  gl_putbox(0,0,640,480,presGif->getPtr());
  for (j=0;j<64;j++) {
    for (i=0;i<256;i++)  {
      re = (presGif->Red[i]>>2) ;
      gr = (presGif->Green[i]>>2) ;
      bl = (presGif->Blue[i]>>2) ;
      re = ((re > j)? j:re);
      gr = ((gr > j)? j:gr);
      bl = ((bl > j)? j:bl);
      gl_setpalettecolor(i,re,gr,bl);
    }
    usleep(15000);
  }
  /* ----- menu page affichee ----- */

  gl_getpalette(defaultPaletteGif);
  Midi_play("midi/spaceboom1.mid");

  /* --- background and pres --- */
  if ((vbuf=(unsigned char *)malloc(1024*512))==NULL) {
    printf("Background : not enough memory.\n");
    exit(0);
  }

  gl_setcontextvirtual(1024,512,1,8,vbuf);
  gl_getcontext(gc_background);
  gl_setcontextvgavirtual(MODE);
  gl_getcontext(gc_pres);
  gl_setcontext(gc_video);
  gl_copyscreen(gc_pres);
  gl_setcontext(gc_pres);

  delete presGif ;

  /*  -- FONT -- */

  gl_setwritemode(FONT_COMPRESSED);
  gl_setfont(8,8,gl_font8x8);
  
  menu1.Add(MAINMENU1);
  menu1.Add(MAINMENU2);
  menu1.Add(MAINMENU3);
  menu1.Add(MAINMENU4);
  menu1.Add(MAINMENU5);

  if (snd)
    menu2.Add(SON_ON);
  else 
    menu2.Add(SON_OFF);

  if (midi)
    menu2.Add(MIDI_ON);
  else
    menu2.Add(MIDI_OFF);

  if (level==1) 
	menu2.Add(LEVEL1);
  if (level==2) 
  	menu2.Add(LEVEL2);
  if (level==4) 
  	menu2.Add(LEVEL3);

  speed = arraySpeed[speedIndex];
  autofire = arrayAutofire[speedIndex] * autofire_fs;
  menu2.Add(SPEED[speedIndex]);


  if (autofire_fs==2)
	menu2.Add(AUTOFIRE1);
  if (autofire_fs==1)
	menu2.Add(AUTOFIRE2);

  menu2.Add("RETURN PREVIOUS MENU");

  menu3.Add(ABOUT1);
  menu3.Add(ABOUT2);
  menu3.Add(ABOUT3);
  menu3.Add(ABOUT4);
  menu3.Add(ABOUT5);

  menu4.Add(MISSION1);
  menu4.Add(MISSION2);
  menu4.Add(MISSION3);
  menu4.Add(MISSION4);

  
  /* --- screen temp --- */
  gl_setpalette(defaultPaletteGif);
  gl_setcontext(gc_pres);
  
  while (1) {

    actualScore = 0; 
    choix1=0;
    
    clearScreen();
    choix1=menu1.Ask();
    clearScreen();
    
    switch (choix1) {
    case 1:
      bestScores.Display();
      gl_copyscreen(gc_video);
      js=readJoystick(0);
      while (!js->b1) js=readJoystick(0);
      clearScreen();      
      break;	
    case 2:
      while ((choix2=menu2.Ask())!=(menu2.mnumber-1)) {
	switch(choix2) {
	case 0:
	  if (snd==1) {
	    snd=0;
	    menu2.Buttons(0)->SetName(SON_OFF);
	  } else {
	    if (soundDev) {
	      snd=1;
	      menu2.Buttons(0)->SetName(SON_ON);
	    }
	  }
	  break;
	case 1:
	  if (midi==1) {
	    Midi_end();
	    menu2.Buttons(1)->SetName(MIDI_OFF);
	  } else {
	      Midi_init(MIDI_CARD);
	      usleep(100000);
	      Midi_play("midi/spaceboom1.mid");
	      usleep(400000);
	      if (midi) {
		menu2.Buttons(1)->SetName(MIDI_ON); 
	      } else {
		menu2.Buttons(1)->SetName(MIDI_OFF);
	      }
	    }
	    break;
	  case 2:
	    if (level==1) {
	      level=2;
	      menu2.Buttons(2)->SetName(LEVEL2);
	    } else if (level==2) {
	      level=4;
	      menu2.Buttons(2)->SetName(LEVEL3);
	    } else if (level==4) {
	      level=1;
	      menu2.Buttons(2)->SetName(LEVEL1);
	    }
	    break;
	  case 3:
	    speedIndex = (speedIndex + 1) % 6;
	    menu2.Buttons(3)->SetName(SPEED[speedIndex]);
	    speed = arraySpeed[speedIndex];
	    autofire = arrayAutofire[speedIndex] * autofire_fs;
	    break;
	  case 4:
	    if (autofire_fs==2) {
	      autofire_fs=1;
	      menu2.Buttons(4)->SetName(AUTOFIRE2);
	      autofire = arrayAutofire[speedIndex] * autofire_fs;
	    } else if (autofire_fs==1) {
	      autofire_fs=2;
	      menu2.Buttons(4)->SetName(AUTOFIRE1);
	      autofire = arrayAutofire[speedIndex] * autofire_fs;
	    } 
	    break;
	  }
	}
	clearScreen();
	break;
      case 3:
	while ((choix3=menu3.Ask())!=(menu3.mnumber-1)) {
	  clearScreen();
	  switch(choix3) {
	  case 0:
	    ecrit(2,2,"I'm born in june 1972 the 14",81);
	    ecrit(2,3,"             in Meudon La Foret near Paris",81);
	    ecrit(2,4,"             in France",81);
	    ecrit(2,6,"I've just finished my studies :",81);
	    ecrit(2,7,"- Engineer in electronics/computer science",81);
	    ecrit(2,8,"- Advanced degree in Acoustics, electronics",81);
	    ecrit(2,9,"  and computer science applied to music.",81);
	    ecrit(2,11,"I've been playing flute for 15 years, i love",81);
	    ecrit(2,12,"my family, my friends, mountains, contemporary",81);
	    ecrit(2,13,"music, astronomy, and LINUX.",81);
	    ecrit(2,15,"To contact me :",81);
	    ecrit(14,16,"Xavier HOSXE",220);
	    ecrit(14,17,"1178 Av roger Salengro",220);
	    ecrit(14,18,"92370 Chaville",220);
	    ecrit(14,19,"FRANCE",220);
	    ecrit(14,20,"Email: hosxe@dds.nl",220);
	    ecrit(13,22,"Press Fire to go back",132);
	    gl_copyscreen(gc_video);
	    js=readJoystick(0);
	    while (!js->b1) js=readJoystick(0);
	    clearScreen();
	    break;
	  case 1:
	    ecrit(3,3,"In july 1995, I discovered svgalib.",81);
	    ecrit(3,4,"Immediately i wanted to try it and i wrote ",81);
	    ecrit(3,5,"a little animation with 50 bouncing balls",81);
	    ecrit(3,6,"going anywhere.",81);
	    ecrit(3,7,"Then i added a background, then interactions,",81);
	    ecrit(3,8,"then a spaceship i was able to control with",81);
	    ecrit(3,9,"the keyboard.",81);
	    ecrit(3,11,"I was astonished by the quickness of svgalib.",81); 
	    ecrit(3,12,"So, i decided to write a game. The games ",81);
	    ecrit(3,13,"i prefer are 'shoot them up', so... ",81);
	    ecrit(3,14,"I coded a first version in C but it was hard",81);
	    ecrit(3,15,"to add new sprites or to change anything.",81);
	    ecrit(3,16,"So, i started again from the beggining in C++.",81);
	    ecrit(3,17,"During my (#!$#) military service (from 1995",81);
	    ecrit(3,18,"october to 1996 July), i finished every day",81);
	    ecrit(3,19,"near midday, so it left me lots of time for",81);
	    ecrit(3,20,"development.",81);
	    ecrit(13,22,"Press Fire to go back",132);
	    gl_copyscreen(gc_video);
	    js=readJoystick(0);
	    while (!js->b1) js=readJoystick(0);
	    clearScreen();
	    break;
	  case 2:
	    ecrit(2,2,"Thanks to :",132);
	    ecrit(2,5,"Frederic DIAS",220);
	    ecrit(16,5,"for the 2 GIF pictures.",81);
	    ecrit(2,7,"Tommy Frandsen, Harm Hanemaayer,",220);
	    ecrit(35,7,"and all who",81);
	    ecrit(2,8,"have contributed to the VGA library",81);
	    ecrit(2,9,"Russel Marks",220);
	    ecrit(15,9,"for his rawkey Library",81);
	    ecrit(2,10,"Brad Pitzel",220);
	    ecrit(14,10,"for his soundIt Library",81);
	    ecrit(2,11,"Patrick J. Naughton",220);
	    ecrit(23,11,"the GIF loading code",81);
	    ecrit(2,12,"Art Smith",220);
	    ecrit(12,12,"for the Joystick driver",81);
	    ecrit(2,14,"                for his C++ advices.",81);
	    ecrit(2,14,"Maarten De Boer",220);
	    ecrit(2,16,"                    for his Unix lessons.",81);
	    ecrit(2,16,"Jean-Paul Bachmann",220);
	    ecrit(2,18,"Thanks to any of those who mailed me suggestions",81);
	    ecrit(2,19,"with a special thanks to",81);
	    ecrit(27,19,"Joe Lee.",220);
	    ecrit(13,22,"Press Fire to go back",132);
	    gl_copyscreen(gc_video);
	    js=readJoystick(0);
	    while (!js->b1) js=readJoystick(0);
	    clearScreen();
	    break;
	  case 3:
	    ecrit(2,4,"HOW TO PLAY :",132);
	    ecrit(2,7,"JOYSTICK:",220);
	    ecrit(2,8,"Use your joystick to move and button 1 to FIRE.",81);
	    ecrit(2,10,"KEYBOARD:",220);
	    ecrit(2,11,"Use the arrow pad to move and <left control> or",81);
	    ecrit(2,12,"<ENTER> to FIRE.",81);
	    ecrit(2,15,"BOTH:",220);
	    ecrit(2,16,"'Q' to die immediately",81);
	    ecrit(2,17,"'P' to make a pause",81);
	    ecrit(13,22,"Press Fire to go back",132);
	    gl_copyscreen(gc_video);
	    js=readJoystick(0);
	    while (!js->b1) js=readJoystick(0);
	    clearScreen();
	    break;
	  default:
	    break;
	  }
	}
	clearScreen();
	break;
      case 4:
	restore_all(1);
	break;
      case 0:
	/* --- init variable --- */
	Continue=1;
	actualScore=0;
	actualPower=200;
	myfire=0;
	Towers = Town = Space = Final = 0;
	menu4.Buttons(0)->SetName(MISSION1);
	menu4.Buttons(1)->SetName(MISSION2);
	menu4.Buttons(2)->SetName(MISSION3);
	menu4.Buttons(3)->SetName(MISSION4);
	while (Continue) {
	  gl_setpalette(defaultPaletteGif);
	  gl_setcontext(gc_pres);
	  clearScreen();
	  sprintf(charpower,"POWER : %i%%",actualPower/2);
	  ecrit(1,2,"PLAYER 1",81);
	  ecrit(1,3,charpower,81);
	  ecrit(1,4,"SCORE :",81);
	  sprintf(charscore,"%i",actualScore);
	  ecrit(9,4,charscore,81);
	  scroll_init();
	  choix2 = menu4.Ask();
	  switch (choix2) {	  
	  case 3:
	    if ((Towers==0) || (Town==0) || (Space==0)) {
	      clearScreen();
	      ecrit(5,7,"You must first finish the 3 other missions",81);
	      ecrit(9,8,"Before meeting your worst enemy !",81);
	      ecrit(15,22,"Press Fire to go back",132);
	      gl_copyscreen(gc_video);
	      js=readJoystick(0);
	      while (!js->b1) js=readJoystick(0);
	      clearScreen();
	      break;	      
	    } else {
	      tableau = tableau4;
	      display = display_last;
	      Midi_play("midi/spaceboom2.mid");
	      Continue = PlaySpaceBoom();
	      if (Continue) {
		gl_setpalette(defaultPaletteGif);
		gl_setcontext(gc_pres);
		clearScreen();
		ecrit(3,4,"SCORE :",81);
		sprintf(charscore,"%i",actualScore);
		ecrit(11,4,charscore,220);
		ecrit(3,7,"You defeated all your enemies",81);
		if (level==1) {
		  ecrit(33,7,"in EASY level.",81);
		  ecrit(3,8,"It's not so bad.",81);
		  ecrit(3,9,"But now, try to play in MEDIUM level,",81);
		  ecrit(3,10,"I think you'll be a little less proud !",81);
		} else if (level==2) {
		  ecrit(33,7,"in MEDIUM level !",81);
		  ecrit(3,8,"You are really strong !",81);
		  ecrit(3,9,"You can now play in the real level : HARD.",81);
		} else if (level==4) {
		  ecrit(33,7,"in HARD level !",81);
		  ecrit(3,8,"You are a real champion !",81);
		  ecrit(3,9,"I can't believe you didn't cheat !",81);
		  ecrit(3,10,"Anyway, CONGRATULATION !",81);
		}
		ecrit(15,22,"Press Fire to go back",132);
		gl_copyscreen(gc_video);
		js=readJoystick(0);
		while (!js->b1) js=readJoystick(0);
		clearScreen();
		Continue=0;
	      }
	      break;
	    }
	  case 0:
	    if (!Town) {
	      tableau = tableau1;
	      display = display_town;
	      Midi_play("midi/spaceboom3.mid");
	      Continue = PlaySpaceBoom();
	      if (Continue ==1) {
		menu4.Buttons(0)->SetName(MISSION1C);
		Town = 1;
	      }
	    }
	    break;
	  case 1:
	    if (!Towers) {
	      tableau = tableau2;
	      display = display_space;
	      Midi_play("midi/spaceboom3.mid");
	      Continue = PlaySpaceBoom();
	      if (Continue ==1) {
		menu4.Buttons(1)->SetName(MISSION2C);
		Towers = 1;
	      }
	    }
	    break;
	    
	    case 2:
	      if (!Space) {
		tableau = tableau3;
		display = display_towers;
		Midi_play("midi/spaceboom3.mid");
		Continue = PlaySpaceBoom();
		if (Continue == 1) {
		  menu4.Buttons(2)->SetName(MISSION3C);
		  Space = 1;
		}
	      }
	    break;
	  }
	}

	/* -- Insert dans les meilleurs scores ? (si meilleurs scores) -- */
	/* --- screen temp --- */
	gl_setpalette(defaultPaletteGif);
	gl_setcontext(gc_pres);
	bestScores.Classement(actualScore);
	clearScreen();
    }
  }
}


